/*
 * Copyright (c) 1994 Noriyuki Shiota.  All rights reserved.
 *
 * $Id: ebw3.c,v 1.5 1996/05/22 19:04:05 root Exp $
 */
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#if defined(sun)
extern char *sys_errlist[];
#endif

#define	DEFAULT_SERVER	"localhost"
#define	DEFAULT_URL	"/cgi-bin/cdsearch"

#define	EBSP_DEFAULT_PORT	9138

#define	TIMEOUT		(3 * 60)	/* 3 minutes */

#define	DEFAULT_GOFFSET	0
#define	MAX_GOFFSET	3

#define	JIS	0
#define	EUC	1
#define	SJIS	2

#define	NSERVER		16
struct server {
	char	*name;
	u_long	addr;
};
struct server servers[NSERVER];
int	nserver;

char	*url;

#define BUFLEN	1024
char	buf[BUFLEN];

#define	MAX_QUERY	256

#define	MESSAGELEN 256
char	message[MESSAGELEN];
char	*address = "by Noriyuki Shiota / nori@shiota.imasy.or.jp";
extern	char *version;

#define	XBUFSIZE	1024
u_char	xbuf[XBUFSIZE];
u_char	*xbp = xbuf;
int	xcnt;
#define	xputc(c, f)	(*xbp++ = (c), (++xcnt >= XBUFSIZE ? xflush(f) : 0))

char	*get_url();

main()
{
	int	s, i, dot, svno, nquery;
	int	code, goff;
	char	*cp;
	char	*path, *curp;
	struct servent *serv, service;
	struct hostent *hp;
	struct sockaddr_in remote;
	char	*query[MAX_QUERY];

	alarm(TIMEOUT);

	goff = DEFAULT_GOFFSET;
	code = JIS;

	url = get_url();
	get_servers();

	if ((serv = getservbyname("ebsp", "tcp")) == NULL) {
		service.s_port = htons(EBSP_DEFAULT_PORT);
		serv = &service;
	}

	nquery = get_query(query, MAX_QUERY);

	path = NULL;
	for  (i = 0; i < nquery; i++) {
		cp = query[i];
		if (strncmp("path=", cp, 5) == 0)
			path = cp + 5;
	}

	if (nquery == 0) {
		home_page(nquery, query, serv->s_port, code, goff);
		exit(0);
	}
	if (path[0] != '/') {
		sprintf(message, "Invalid path: \"%s\"", path);
		error(message);
		exit(1);
	}

	curp = &path[1];
	if (strncmp(curp, "option/", 7) == 0) {
		set_option_kanji(curp + 7);
		exit(0);
	}

	if (strncmp(curp, "jis/", 4) == 0) {
		code = JIS;
		curp += 4;
	}
	else if (strncmp(curp, "euc/", 4) == 0) {
		code = EUC;
		curp += 4;
	}
	else if (strncmp(curp, "sjis/", 5) == 0) {
		code = SJIS;
		curp += 5;
	}

	if (strcmp(curp, "option/") == 0) {
		set_option_goff(code);
		exit(0);
	}
	if (curp[0] == 'g') {
		dot = strtol(curp + 1, (char **)&cp, 10);
		if (*cp == '/')
			cp++;
		curp = cp;
		if (dot > MAX_GOFFSET)
			dot = MAX_GOFFSET;
		goff = dot;
	}

	if (*curp == 0) {
		home_page(nquery, query, serv->s_port, code, goff);
		exit(0);
	}

	svno = strtol(curp, &cp, 0);

	if (cp == curp || svno > nserver) {
		error("invalid server number");
		exit(1);
	}

	if ((hp = gethostbyname(servers[svno].name)) == NULL) {
		sprintf(message, "Invalid CD server \"%s\" (host not found)\n",
			servers[svno].name);
		error(message);
	}

	if ((s = socket(PF_INET, SOCK_STREAM, 0)) == -1)
		syserror("socket");

	bzero(&remote, sizeof(remote));
#if defined(__NetBSD__) || defined(__bsdi__) || defined(__FreeBSD__)
	remote.sin_len = sizeof(remote);
#endif
	remote.sin_family = AF_INET;
	remote.sin_port = serv->s_port;
	bcopy(hp->h_addr, &remote.sin_addr.s_addr, sizeof(long));
	if (connect(s, (struct sockaddr *)&remote, sizeof(remote)) == -1)
		syserror("connect");

	put_query(s, nquery, query, NULL);

	while ((xcnt = read(s, xbuf, XBUFSIZE)) > 0) {
		xbp = &xbuf[xcnt];
		xflush(1);
	}
	shutdown(s, 2);
	close(s);
	exit(0);
}

home_page(nquery, query, port, code, goff)
	char	**query;
	u_short port;
{
	int	i, s, cc;
	char	*cd;
	struct	server *sp;
	struct	hostent *hp;
	struct	sockaddr_in sin;
	char	pathbuf[10];

	cd = code == SJIS ? "sjis" : code == EUC ? "euc" : "jis";

	printf("Content-Type: text/html\n\n");
	printf("<HTML>\n<HEAD>\n<TITLE>EB-W3 Home Page</TITLE>\n</HEAD>\n");
	printf("<BODY>\n<H1>EB-W3 Home Page</H1>\n\n");
	eputs(code, "<H2>Ѥãġݣңϣͤǲ</H2><P>\n\n");

	for (i = 0; i < nserver; i++) {
		sp = &servers[i];
		printf("<UL><H3>");
		if ((hp = gethostbyname(sp->name)) == NULL) {
			printf("[%s]: host unknown.</H3>\n</UL>\n\n", sp->name);
			continue;
		}
		if ((s = socket(PF_INET, SOCK_STREAM, 0)) == -1) {
			printf("[%s]: socket: %s</H3>\n</UL>\n\n",
				 sp->name, sys_errlist[errno]);
			continue;
		}
		bzero(&sin, sizeof(sin));
#if defined(__NetBSD__) || defined(__bsdi__) || defined(__FreeBSD__)
		sin.sin_len = sizeof(sin);
#endif
		sin.sin_family = AF_INET;
		sin.sin_port = port;
		bcopy(hp->h_addr, &sin.sin_addr.s_addr, sizeof(long));
		if (connect(s, (struct sockaddr *)&sin, sizeof(sin)) == -1) {
			printf("[%s]: connect: %s</H3>\n</UL>\n\n",
				sp->name, sys_errlist[errno]);
			close(s);
			continue;
		}
		printf("[%s]</H3>\n", sp->name);
		sprintf(pathbuf, "/%s/g%d/%d/", cd, goff, i);
		put_query(s, nquery, query, pathbuf);
		while ((cc = read(s, buf, BUFLEN)) > 0)
			fwrite(buf, 1, cc, stdout);
		shutdown(s, 2);
		close(s);
		printf("</UL><P>\n");
	}
	printf("<UL><H3>[option]</H3>\n");
	printf("<LI><A HREF=\"%s?path=/option/g%d/\">Setup Kanji code</A>\n",
		url, goff);
	printf("<LI><A HREF=\"%s?path=/%s/option/\">Setup Gaiji offset</A>\n",
		url, cd);
	printf("</UL>\n");
	printf("<P><HR><P>");
	printf("Ebw3 Version %s<BR>\n<ADDRESS>%s</ADDRESS>\n</BODY>\n</HTML>\n",
		version, address);
}

set_option_kanji(curp)
	char *curp;
{
	printf("Content-Type: text/html\n\n");
	printf("<HTML>\n<HEAD>\n<TITLE>Setup Kanji Code</TITLE>\n</HEAD>\n");
	printf("<BODY>\n<H1>Select Kanji Code.</H1>\n\n");
	printf("<UL>\n");
	printf("<LI><A HREF=\"%s?path=/jis/%s\">JIS</A>\n", url, curp);
	printf("<LI><A HREF=\"%s?path=/euc/%s\">EUC</A>\n", url, curp);
	printf("<LI><A HREF=\"%s?path=/sjis/%s\">Shift-JIS</A>\n", url, curp);
	printf("</UL>\n</BODY>\n</HTML>\n");
}

set_option_goff(code)
{
	char	*cd;

	if (code == SJIS)
		cd = "sjis";
	else if (code == EUC)
		cd = "euc";
	else
		cd = "jis";

	printf("Content-Type: text/html\n\n");
	printf("<HTML>\n<HEAD>\n<TITLE>Setup Gaiji offset</TITLE>\n</HEAD>\n");
	printf("<BODY>\n<H1>Select Gaiji offset.</H1>\n\n");
	printf("<UL>\n");
	printf("<LI><A HREF=\"%s?path=/%s/g0/\">No padding</A>\n", url, cd);
	printf("<LI><A HREF=\"%s?path=/%s/g1/\">Padding 1 dot</A>\n", url, cd);
	printf("<LI><A HREF=\"%s?path=/%s/g2/\">Padding 2 dot</A>\n", url, cd);
	printf("<LI><A HREF=\"%s?path=/%s/g3/\">Padding 3 dot</A>\n", url, cd);
	printf("</UL>\n</BODY>\n</HTML>\n");
}

get_query(query, max)
	u_char **query;
{
	int	c, ind, val;
	char	*envp;
	u_char	*cp, *dp;

	ind = 0;
	query[ind] = NULL;
	if ((envp = getenv("QUERY_STRING")) == NULL)
		return ind;
	for (cp = envp, dp = envp; *cp; cp++, dp++) {
		if (query[ind] == NULL)
			query[ind] = dp;
		if ((c = *cp) == '%') {
			sscanf(cp + 1, "%2x", &val);
			*dp = val;
			cp += 2;
		}
		else if (c == '&') {
			*dp = 0;
			query[++ind] = NULL;
			if (ind >= max)
				return ind;
		}
		else if (c == '+')
			*dp = ' ';
		else
			*dp = c;
	}
	*dp = 0;
	if (query[ind])
		ind++;
	return ind;
}

get_servers()
{
	char	*cp;

	if ((cp = getenv("SERVERS")) == NULL) {
		servers[0].name = DEFAULT_SERVER;
		nserver++;
		return;
	}
	while (*cp) {
		for (; *cp && isspace(*cp); cp++)
			;
		if (*cp == 0)
			break;
		if (nserver >= NSERVER) {
			error("too many server");
			exit(1);
		}
		servers[nserver++].name = cp;
		for (; *cp && !isspace(*cp); cp++)
			;
		if (*cp)
			*cp++ = 0;
	}
}

char	*
get_url()
{
	char	*cp;

	if (cp = getenv("URL"))
		return cp;
	return DEFAULT_URL;
}

put_query(f, nquery, query, str)
	u_char	**query;
	char	*str;
{
	int	i;
	u_char	*cp;

	for (i = 0; i < nquery; i++) {
		cp = query[i];
		if (str != NULL && strncmp(cp, "path=", 5) == 0)
			continue;
		xputs(cp, f);
		xputc('\n', f);
	}
	if (str != NULL) {
		sprintf(buf, "path=%s\n", str);
		xputs(buf, f);
	}
	xputs("url=", f);
	xputs(url, f);
	xputc('\n', f);
	xputc('\n', f);
	xflush(f);
}

syserror(msg)
	char	*msg;
{
	sprintf(message, "%s: %s", msg, sys_errlist[errno]);
	error(message);
}

error(msg)
	char	*msg;
{
	printf("Content-Type: text/html\n\n");
	printf("<HTML>\n<HEAD>\n<TITLE>Error</TITLE>\n</HEAD>\n");
	printf("<BODY>\n<H1>EB-W3 ERROR</H1>\n\n");
	printf("%s\n", msg);
	printf("<P><HR>\n<ADDRESS>%s</ADDRESS>\n</BODY>\n</HTML>\n", address);
	exit(1);
}

xputs(buf, f)
	u_char	*buf;
{
	int	c, cnt;
	u_char	*cp, *bp;

	cnt = xcnt;
	cp = buf;
	bp = xbp;
	while (c = *cp++) {
		*bp++ = c;
		if (++cnt >= XBUFSIZE) {
			xcnt = cnt;
			xbp = bp;
			xflush(f);
			bp = xbuf;
			cnt = 0;
		}
	}
	xcnt = cnt;
	xbp = bp;
}

xflush(f)
{
	int	cc, cnt = xcnt;
	u_char	*bp;

	if (cnt == 0)
		return;

	bp = xbuf;

	while (cnt > 0) {
		if ((cc = write(f, bp, cnt)) < 0) {
			if (errno != EINTR) {
				perror("xflush: write");
				exit(1);
			}
			continue;
		}
		cnt -= cc;
		bp += cc;
	}
	xcnt = 0;
	xbp = xbuf;
}

eputs(code, str)
	u_char *str;
{
	switch (code) {
	case JIS:
		jisputs(str, stdout);
		break;
	case EUC:
		fputs(str, stdout);
		break;
	case SJIS:
		sjisputs(str, stdout);
		break;
	}
}

#define	KI	"\033$B"
#define	KO	"\033(B"
#define	SI	0xf
#define	SO	0xe

int	inkanji, inkana;

jisputs(buf, fp)
	u_char	*buf;
	FILE	*fp;
{
	int	c;
	u_char	*s = buf;

	while (c = *s++) {
		if (c == 0x8e) {
			if (inkanji) {
				fputs(KO, fp);
				inkanji = 0;
			}
			if (inkana == 0) {
				putc(SO, fp);
				inkana = 1;
			}
			putc(*s++ & 0x7f, fp);
		}
		else if (c >= 0xa1) {
			if (inkana) {
				putc(SI, fp);
				inkana = 0;
			}
			if (inkanji == 0) {
				fputs(KI, fp);
				inkanji = 1;
			}
			putc(c & 0x7f, fp);
			putc(*s++ & 0x7f, fp);
		}
		else {
			if (inkana) {
				putc(SI, fp);
				inkana = 0;
			}
			if (inkanji) {
				fputs(KO, fp);
				inkanji = 0;
			}
			putc(c, fp);
		}
	}
}

sjisputs(buf, fp)
	u_char	*buf;
	FILE	*fp;
{
	int	c;
	u_short	code;
	u_char	*s = buf;

	while (c = *s++) {
		if (c == 0x8e && *s)
			putc(*s++, fp);
		else if (c >= 0xa1 && *s) {
			code = jtos(((c & 0x7f) << 8) | (*s++ & 0x7f));
			putc(code >> 8, fp);
			putc(code & 0xff, fp);
		}
		else
			putc(c, fp);
	}
}

jtos(code)
	unsigned int code;
{
	register unsigned int	hi, hi0, lo;

	hi0 = code >> 8;
	hi  = hi0 >> 1;
	lo  = (code + 0x1f) & 0xff;
	if ((hi0 & 1) == 0) {
		hi--;
		lo += 0x5e;
	}
	if (lo >= 0x7f)
		lo++ ;
	if (hi <= 0x2e)
		hi += 0x71;
	else
		hi += 0xb1;
	return((hi << 8) + lo);
}
