/*
 * Copyright (c) 1994,1995 Noriyuki Shiota.  All rights reserved.
 *
 * $Id: init.c,v 1.6 1997/05/23 16:08:24 root Exp $
 *
 *	롼
 */
#include <sys/types.h>
#include <fcntl.h>
#include <limits.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <ctype.h>
#include <errno.h>
#include "ebs.h"
#include "format.h"
#if defined(sun)
#include <sys/param.h>
#define	PATH_MAX	MAXPATHLEN
#endif

struct disc	*discp;

#define	BUFSZ	512
static char	linebuf[BUFSZ];
static char	pathbuf[PATH_MAX + 1];	/* PATH_MAX is defined in <limits.h> */


/*
 *   config fileɤdisc¤Τ
 */
read_config()
{
	struct disc *dc;
	FILE	*fp;
	char	*cp, *path, *desc;
	int	line, err, len, gtblno;

	if ((fp = fopen(CONFIG_FILE, "r")) == NULL) {
		perror(CONFIG_FILE);
		return -1;
	}
	line = err = 0;
	gtblno = -1;
	while (fgets(linebuf, BUFSZ, fp) != NULL) {
		line++;
		len = strlen(linebuf);
		if (len > 0 && linebuf[len - 1] == '\n')
			linebuf[--len] = 0;
		if (len == 0)
			continue;
		if (index("#; ", linebuf[0]))
			continue;
		for (cp = linebuf; *cp && !isspace(*cp); cp++)
			;
		if (*cp)
			*cp++ = 0;
		if (strcmp(linebuf, "disc") == 0) {
			for (; isspace(*cp); cp++)
				;
			if (*cp == 0)
				goto bad;
			for (path = cp; *cp && *cp != ' ' && *cp != '\t'; cp++)
				;
			if (*cp == 0)
				goto bad;
			*cp++ = 0;
			for (; *cp == ' ' || *cp == '\t'; cp++)
				;
			desc = cp;
			dc = xmalloc(sizeof(struct disc));
			bzero(dc, sizeof(struct disc));
			dc->dc_path = strdup(path);
			dc->dc_name = strdup(desc);
			dc->dc_next = discp;
			discp = dc;
			gtblno = 0;
			continue;
		}
#ifdef notyet
		if (linebuf[0] == 0) {	/* ³(ɽ)ξ */
			for (; isspace(*cp); cp++)
				;
			if (*cp == 0)
				continue;
			for (path = cp; *cp && !isspace(*cp); cp++)
				;
			*cp = 0;
			if (discp == NULL || gtblno == -1)
				goto bad;
			gtblno++;
			init_gaiji_alt(discp, gtblno, path);
		}
#endif
	bad:
		fprintf(stderr, "%s: syntax error in line %d\n",
			CONFIG_FILE, line);
		err++;
	}
	fclose(fp);
	/*
	 *   Reverse disc list
	 */
	reverse(&discp);

	return (err ? -1 : 0);
}

/*
 *   եɤdisc¤Τ˵ܤ줿
 *   ҤȤdict¤Τ
 */
read_catalog()
{
	int	i, f, num;
	FILE	*fp;
	struct disc	*dc;
	struct dict	*dt;
	struct cat_head head;

	num = 0;
	for (dc = discp; dc; dc = dc->dc_next) {
		/*
		 *   cd ޥȤƤchdirե
		 *   ץ󤹤
		 */
		if (chdir(dc->dc_path) == -1)
			continue;
		if ((fp = fopen(EPW_CATALOG, "r")) == NULL) {
			sprintf(pathbuf, "%s.", EPW_CATALOG);
			if ((fp = fopen(pathbuf, "r")) == NULL) {
				strcat(pathbuf, ";");
				if ((fp = fopen(pathbuf, "r")) == NULL)
					goto check_eb;
			}
		}
		/* catalogs äEPWING */
		dc->dc_flags = DCF_EPWING;
		goto found;

	check_eb:
		if ((fp = fopen(EB_CATALOG, "r")) == NULL) {
			sprintf(pathbuf, "%s.", EB_CATALOG);
			if ((fp = fopen(pathbuf, "r")) == NULL) {
				strcat(pathbuf, ";");
				if ((fp = fopen(pathbuf, "r")) == NULL)
					continue;	/*  */
			}
		}
		/* catalog äEB */
		dc->dc_flags = DCF_EBOOK;

	found:
		/*
		 *  Υإåɤ
		 */
		if (xfread(&head, sizeof(head), 1, fp, "catalog haeder") != 1)
			goto next;
		dc->dc_ndict = ntohs(head.numbook);
		dc->dc_dict = NULL;
		/*
		 *  ҿʬνҥ쥳ɤɤǡdict¤Τ
		 */
		for (i = 0; i < dc->dc_ndict; i++)
			init_dict(dc, fp);		/* XXXX ignore error */
		reverse(&dc->dc_dict);
		dc->dc_discno = ++num;
		i = 0;
		mkdir("/tmp/.ebw3d", 0700);
		for (dt = dc->dc_dict; dt; dt = dt->dt_next) {
			dt->dt_dictno = ++i;		/* set dictno */
			sprintf(pathbuf, "/tmp/.ebw3d/lock.%d.%d", num, i);
			if ((f = open(pathbuf, O_RDWR|O_CREAT, 0600)) == -1) {
				perror(pathbuf);
				fprintf(stderr, "ebw3d: can't create lockfile\n");
				return -1;
			}
			close(f);
			dt->dt_lockpath = strdup(pathbuf);

		}
		dc->dc_flags |= DCF_VALID;	/*  */
	next:
		fclose(fp);
	}
	return 0;
}

/*
 *   fp ҥ쥳ɤɤdict¤Τdc_dictˤĤʤ
 */
init_dict(dc, fp)
	struct disc *dc;
	FILE	*fp;
{
	int	i;
	FILE	*dfp;
	u_char	*cp;
	struct dict *dt;
	struct toc *tp;
	struct cat_book_eb eb;
	struct cat_book_ep epw;
	struct bk_head bh;

	if (dc->dc_flags & DCF_EBOOK) {		/* EB ξ */
		/*
		 *  ҥ쥳ɤɤ߹
		 */
		if (xfread(&eb, sizeof(eb), 1, fp, "catalog info") != 1)
			return -1;

		/* little endianοhost shortѴ */
		eb.bookno = letohs(eb.bookno);

		/* ǥ쥯ȥ̾stringѴ */
		fname2str(eb.dir, pathbuf, EB_DIRLEN);
		/*
		 *  ᥤեΥץ
		 */
		sprintf(pathbuf + strlen(pathbuf), "/%s", EB_MAINFILE);
		if ((dfp = fopen(pathbuf, "r")) == NULL) {
			strcat(pathbuf, ".");
			if ((dfp = fopen(pathbuf, "r")) == NULL) {
				strcat(pathbuf, ";");
				if ((dfp = fopen(pathbuf, "r")) == NULL)
					return -1;
			}
		}
		/*
		 *  ܼإåɤ߹
		 */
		if (xfread(&bh, sizeof(bh), 1, dfp, "toc header") != 1) {
			fclose(dfp);
			return -1;
		}
		bh.numtoc = ntohs(bh.numtoc);
		/*
		 *  dict¤Τalloc
		 */
		dt = xmalloc(sizeof(struct dict));
		bzero(dt, sizeof(struct dict));
		dt->dt_disc = dc;
		dt->dt_next = dc->dc_dict;
		dc->dc_dict = dt;
		dt->dt_fp = dfp;
		dt->dt_path = strdup(pathbuf);
		fname2str(eb.dir, pathbuf, EB_DIRLEN);
		dt->dt_dir = strdup(pathbuf);
		dt->dt_name = toeuc(eb.name, EB_BOOKNAMELEN);
		/*
		 * Ⱦѳʤ硢νʤ1byteʸ򤹤٤
		 * ȤưäƤޤΤǡ줬ɬפǤ롣
		 *	from MASUTANI Yasuhiro <masutani@me.es.osaka-u.ac.jp>
		 */
		dt->dt_ghbase = 0xffff;
		dt->dt_gfbase = 0xffff;
		/*
		 *  ܼοbk_toc¤Τalloc
		 */
		for (i = 0; i < bh.numtoc; i++) {
			if (init_toc(dt, dfp) == -1) {
				fclose(dfp);
				return -1;
			}
		}
		/*
		 *   search gaiji file
		 */
		for (tp = dt->dt_toc; tp; tp = tp->tc_next) {
			if (tp->tc_type == T_GAIJI_FULL16)
				init_gaiji_eb(tp, dfp, 1);
			else if (tp->tc_type == T_GAIJI_HALF16)
				init_gaiji_eb(tp, dfp, 0);
		}
	}
	else if (dc->dc_flags & DCF_EPWING) {	/* EPWING ξ */
		/*
		 *  ҥ쥳ɤɤ߹
		 */
		if (xfread(&epw, sizeof(epw), 1, fp, "catalog info") != 1)
			return -1;

		/* ǥ쥯ȥ̾stringѴ */
		fname2str(epw.dir, pathbuf, EPW_DIRLEN);
		/*
		 *  ᥤեΥץ
		 */
		sprintf(pathbuf + strlen(pathbuf), "/%s", EPW_MAINFILE);
		if ((dfp = fopen(pathbuf, "r")) == NULL) {
			strcat(pathbuf, ".");
			if ((dfp = fopen(pathbuf, "r")) == NULL)
				return -1;
		}
		/*
		 *  ܼإåɤ߹
		 */
		if (xfread(&bh, sizeof(bh), 1, dfp, "toc header") != 1) {
			fclose(dfp);
			return -1;
		}
		bh.numtoc = ntohs(bh.numtoc);
		/*
		 *  dict¤Τalloc
		 */
		dt = xmalloc(sizeof(struct dict));
		bzero(dt, sizeof(struct dict));
		dt->dt_disc = dc;
		dt->dt_next = dc->dc_dict;
		dc->dc_dict = dt;
		dt->dt_fp = dfp;
		dt->dt_path = strdup(pathbuf);
		fname2str(epw.dir, pathbuf, EPW_DIRLEN);
		dt->dt_dir = strdup(pathbuf);
		dt->dt_name = toeuc(epw.name, EPW_BOOKNAMELEN);
		/*
		 * Ⱦѳʤ硢νʤ1byteʸ򤹤٤
		 * ȤưäƤޤΤǡ줬ɬפǤ롣
		 *	from MASUTANI Yasuhiro <masutani@me.es.osaka-u.ac.jp>
		 */
		dt->dt_ghbase = 0xffff;
		dt->dt_gfbase = 0xffff;
		/*
		 *  ܼοbk_toc¤Τalloc
		 */
		for (i = 0; i < bh.numtoc; i++) {
			if (init_toc(dt, dfp) == -1) {
				fclose(dfp);
				return -1;
			}
		}
		/*
		 *  եν
		 */
		sprintf(pathbuf, "%s/%s/", dt->dt_dir, EPW_GAIJIDIR);
		cp = &pathbuf[strlen(pathbuf)];
		if (fname2str(epw.gf16, cp, EPW_GAFILELEN) > 0)
			init_gaiji_epw(dt, pathbuf, 16, 1);
		if (fname2str(epw.gf24, cp, EPW_GAFILELEN) > 0)
			init_gaiji_epw(dt, pathbuf, 24, 1);
		if (fname2str(epw.gf30, cp, EPW_GAFILELEN) > 0)
			init_gaiji_epw(dt, pathbuf, 30, 1);
		if (fname2str(epw.gf48, cp, EPW_GAFILELEN) > 0)
			init_gaiji_epw(dt, pathbuf, 48, 1);
		if (fname2str(epw.gh16, cp, EPW_GAFILELEN) > 0)
			init_gaiji_epw(dt, pathbuf, 16, 0);
		if (fname2str(epw.gh24, cp, EPW_GAFILELEN) > 0)
			init_gaiji_epw(dt, pathbuf, 24, 0);
		if (fname2str(epw.gh30, cp, EPW_GAFILELEN) > 0)
			init_gaiji_epw(dt, pathbuf, 30, 0);
		if (fname2str(epw.gh48, cp, EPW_GAFILELEN) > 0)
			init_gaiji_epw(dt, pathbuf, 48, 0);
	}
	else
		return -1;

	reverse(&dt->dt_toc);
	i = 0;
	for (tp = dt->dt_toc; tp; tp = tp->tc_next)
		tp->tc_tocno = ++i;		/* set tocno */

	/*
	 *   init wordsrch structure
	 */
	init_wordsrch(dt);

	return 0;
}

/*
 *  dfp ܼɤtoc¤Τdt->dt_tocˤĤʤ
 */
init_toc(dt, dfp)
	struct dict *dt;
	FILE	*dfp;
{
	int	n;
	struct bk_toc toc;
	struct toc *tp, *p;
	u_char	*cp;

	/*
	 *   ܼɤ
	 */
	if (xfread(&toc, sizeof(toc), 1, dfp, "toc") != 1)
		return -1;
	/*
	 *   toc¤Τalloc
	 */
	tp = xmalloc(sizeof(struct toc));
	tp->tc_dict = dt;
	tp->tc_next = dt->dt_toc;
	dt->dt_toc = tp;			/* toc¤Τȥ */
	tp->tc_type = toc.type;
	cp = toc.start;
	tp->tc_start = (cp[0] << 24) + (cp[1] << 16) + (cp[2] << 8) + cp[3];
	cp = toc.length;
	tp->tc_length = (cp[0] << 24) + (cp[1] << 16) + (cp[2] << 8) + cp[3];
	tp->tc_flags = 0;
	/*
	 *   Ʊפܼʤ
	 *   tc_noκ+1tc_no˥å
	 */
	n = -1;
	for (p = tp->tc_next; p; p = p->tc_next) {
		if (p->tc_type == tp->tc_type) {
			n = MAX(n, p->tc_no);
			tp->tc_flags |= TCF_MULTI;
			p->tc_flags |= TCF_MULTI;
		}
	}
	tp->tc_no = n + 1;
	return 0;
}

/*
 *   եɤ߹struct gaiji(Żҥ֥åξ)
 */
init_gaiji_eb(tc, dfp, full)
	struct toc *tc;
	FILE	*dfp;
{
	long	offset;
	struct dict *dt = tc->tc_dict;
	struct gaiji *gj;
	struct gj_head gh;

	offset = (tc->tc_start - 1) * FRAMESIZE;
	if (xfseek(dfp, offset, SEEK_SET, "init gai") == -1)
		return;
	if (xfread(&gh, sizeof(gh), 1, dfp, "init gai") != 1)
		return;
	gj = xmalloc(sizeof(struct gaiji));
	bzero(gj, sizeof(struct gaiji));
	gj->gj_dict = dt;
	gj->gj_next = dt->dt_gaiji;
	dt->dt_gaiji = gj;
	gj->gj_fp = dfp;
	gj->gj_offset = offset + FRAMESIZE;
	gj->gj_basecode = ntohs(gh.start);
	gj->gj_nchars = ntohs(gh.nchars);
	gj->gj_file_width = gh.width;
	gj->gj_file_height = gh.height;
	gj->gj_width = gh.width;
	gj->gj_height = gh.height;
	if (full == 0) {
		gj->gj_flags = GJF_HANKAKU;
		dt->dt_ghbase = gj->gj_basecode;
	}
	else
		dt->dt_gfbase = gj->gj_basecode;
}

/*
 *   եɤ߹struct gaiji(EPWINGξ)
 */
init_gaiji_epw(dt, file, height, full)
	struct dict *dt;
	u_char	*file;
{
	FILE	*fp;
	int	len;
	struct	gaiji *gj;
	struct	gj_head gh;

	if (*file == 0)
		return;
	if ((fp = fopen(file, "r")) == NULL) {
		strcat(file, ".");
		if ((fp = fopen(file, "r")) == NULL) {
			strcat(file, ";");
			if ((fp = fopen(file, "r")) == NULL) {
				perror(file);
				return;
			}
		}
	}
	if (xfread(&gh, sizeof(gh), 1, fp, "gaiji") != 1) {
		fclose(fp);
		return;
	}
	gj = xmalloc(sizeof(struct gaiji));
	bzero(gj, sizeof(struct gaiji));
	gj->gj_dict = dt;
	gj->gj_next = dt->dt_gaiji;
	dt->dt_gaiji = gj;
	gj->gj_path = strdup(file);
	gj->gj_offset = FRAMESIZE;
	gj->gj_basecode = ntohs(gh.start);
	gj->gj_nchars = ntohs(gh.nchars);
	gj->gj_file_width = gh.width;
	gj->gj_file_height = gh.height;
	gj->gj_width = full ? height : height / 2;
	gj->gj_height = height;
	gj->gj_flags = GJF_SEPARATE;
	if (height == 16) {
		gj->gj_fp = fp;
		if (full)
			dt->dt_gfbase = gj->gj_basecode;
		else
			dt->dt_ghbase = gj->gj_basecode;
	}
	else
		fclose(fp);
	if (full == 0)
		gj->gj_flags |= GJF_HANKAKU;
	len = (gh.width / 8) * gh.height;
	if (GALIGN % len) {
		/*
		 *   ǡˤϳ1ʸʬΥǡpage boundary
		 *   ʤ褦paddingäƤ롣Ǥpadding
		 *   ̤׻Ƥ
		 */
		gj->gj_unit = GALIGN / len;
		gj->gj_adj = GALIGN - gj->gj_unit * len;
		gj->gj_flags |= GJF_NEEDADJ;
	}
}

#ifdef notyet
/*
 *  ɽɤ߹
 */
init_gaiji_alt(dc, gtblno, path)
	struct disc *dc;
	char *path;
{
	struct dict *dt;

	/*
	 *  gtblno ܤμ򸫤Ĥ
	 */
	for (dt = dc->dc_dict; dt && dt->dt_dictno != gtblno; dt = dt->dt_next)
		;
	/*
	 *  񤬤ʤä̵뤹
	 */
	if (dt == NULL)
		return;
	
}
#endif

int	do_cond(), do_cross(), do_number(), do_page(), do_soukaku();
int	do_busyukaku(), do_multi(), do_menu(), do_graph(), do_copyright();
int	do_honmon();

struct	toctbl toctbl[] = {
	{ T_INDEX_FORW_KANA,	ST_WORD|SD_FORW|SC_KANA,
	  NULL,			"ñ측()" },
	{ T_INDEX_FORW,		ST_WORD|SD_FORW|SC_HYOUKI,
	  NULL,			"ɽñ측()" },
	{ T_INDEX_FORW_ALPHA,	ST_WORD|SD_FORW|SC_ALPHA,
	  NULL,			"ѻñ측()" },
	{ T_INDEX_BACK_KANA,	ST_WORD|SD_BACK|SC_KANA,
	  NULL,			"ñ측()" },
	{ T_INDEX_BACK,		ST_WORD|SD_BACK|SC_HYOUKI,
	  NULL,			"ɽñ측()" },
	{ T_INDEX_BACK_ALPHA,	ST_WORD|SD_BACK|SC_ALPHA,
	  NULL,			"ѻñ측()" },
	{ T_INDEX_KANA,		ST_WORD|SD_EXACT|SC_KANA,
	  NULL,			"ñ측" },
	{ T_INDEX_KANJI,	ST_WORD|SD_EXACT|SC_KANJI,
	  NULL,			"ñ측" },
	{ T_INDEX_HYOKI,	ST_WORD|SD_EXACT|SC_HYOUKI,
	  NULL,			"ɽñ측" },
	{ T_INDEX_ALPHA,	ST_WORD|SD_EXACT|SC_ALPHA,
	  NULL,			"ѻñ측" },
	{ T_INDEX_COND,		ST_COND,
	  do_cond,		"︡" },
#ifdef NORI
	{ T_INDEX_CROSS,	ST_CROSS,
	  do_cross,		"Ф︡" },
	{ T_INDEX_NUMBER,	ST_NUMBER,
	  do_number,		"ֹ渡" },
	{ T_INDEX_PAGE,		ST_PAGE,
	  do_page,		"ڡ" },
	{ T_INDEX_SOUKAKU,	ST_SOUKAKU,
	  do_soukaku,		"" },
	{ T_INDEX_BUSYUKAKU,	ST_BUSYUKAKU,
	  do_busyukaku,		"" },
	{ T_MULTI_INDEX,	ST_MULTI,
	  do_multi,		"ʣ縡" },
#endif
	{ T_MENU,		ST_NORM,
	  do_menu,		"˥塼" },
	{ T_GRAPH,		ST_GRAPH,
	  do_graph,		"եå" },
	{ T_COPYRIGHT,		ST_NORM,
	  do_copyright,		"ɽ" },
	{ T_HONMON,		ST_NORM,
	  do_honmon,		"ʸɽ" },
	{ 0,			0,
	  NULL,			NULL },
};

init_wordsrch(dt)
	struct dict *dt;
{
	int	ind, flags;
	u_char	*name;
	struct	toc	*tp;
	struct	wordsrch *wp;
	struct	toctbl	*tbp;

	wp = xmalloc(sizeof(struct wordsrch));
	bzero(wp, sizeof(struct wordsrch));

	for (tp = dt->dt_toc; tp; tp = tp->tc_next) {
		for (tbp = toctbl; tbp->name; tbp++) {
			if (tbp->type == tp->tc_type)
				goto found;
		}
		continue;
	found:
		flags = tbp->flags;
		if ((flags & ST_MASK) != ST_WORD)
			continue;
		switch (flags & SC_MASK) {
		case SC_KANA:
			ind = WD_KANA;
			break;
		case SC_HYOUKI:
			ind = WD_HYOUKI;
			break;
		case SC_ALPHA:
			ind = WD_ALPHA;
			break;
		case SC_KANJI:
			ind = WD_KANJI;
			break;
		default:
			abort();
		}
		wp->ws_type |= flags & SC_MASK;
		switch (flags & SD_MASK) {
		case SD_FORW:
			wp->ws_forw[ind] = tp;
			break;
		case SD_BACK:
			wp->ws_back[ind] = tp;
			break;
		case SD_EXACT:
			wp->ws_exact[ind] = tp;
			break;
		default:
			abort();
		}
		wp->ws_type |= flags & SD_MASK;
	}

	if (wp->ws_type == 0) {
		xfree(wp);
		dt->dt_word = NULL;
		return;
	}
	wp->ws_dict = dt;
	dt->dt_word = wp;

	if (wp->ws_exact[WD_KANA] == NULL) {
		if (wp->ws_forw[WD_KANA] != NULL)
			wp->ws_exact[WD_KANA] = wp->ws_forw[WD_KANA];
		else if (wp->ws_back[WD_KANA] != NULL)
			wp->ws_exact[WD_KANA] = wp->ws_back[WD_KANA];
	}
	if (wp->ws_exact[WD_HYOUKI] == NULL) {
		if (wp->ws_forw[WD_HYOUKI] != NULL)
			wp->ws_exact[WD_HYOUKI] = wp->ws_forw[WD_HYOUKI];
		else if (wp->ws_back[WD_HYOUKI] != NULL)
			wp->ws_exact[WD_HYOUKI] = wp->ws_back[WD_HYOUKI];
	}
	if (wp->ws_exact[WD_ALPHA] == NULL) {
		if (wp->ws_forw[WD_ALPHA] != NULL)
			wp->ws_exact[WD_ALPHA] = wp->ws_forw[WD_ALPHA];
		else if (wp->ws_back[WD_ALPHA] != NULL)
			wp->ws_exact[WD_ALPHA] = wp->ws_back[WD_ALPHA];
	}
	if (wp->ws_exact[WD_KANJI] == NULL) {
		if (wp->ws_forw[WD_KANJI] != NULL)
			wp->ws_exact[WD_KANJI] = wp->ws_forw[WD_KANJI];
		else if (wp->ws_back[WD_KANJI] != NULL)
			wp->ws_exact[WD_KANJI] = wp->ws_back[WD_KANJI];
	}

	name = wp->ws_name;
	name[0] = 0;
	if (wp->ws_type & SD_EXACT)
		strcat(name, "");
	if (wp->ws_type & SD_FORW) {
		if (name[0])
			strcat(name, ", ");
		strcat(name, "");
	}
	if (wp->ws_type & SD_BACK) {
		if (name[0])
			strcat(name, ", ");
		strcat(name, "");
	}
}

initialize()
{
	if (read_config() == -1)
		exit(1);
	if (read_catalog() == -1)
		exit(1);
}
