/*
 * Copyright (c) 1994,1995 Noriyuki Shiota.  All rights reserved.
 *
 * $Id: kanji.c,v 1.4 1996/05/22 19:04:05 root Exp $
 */
#include <sys/types.h>
#include <stdlib.h>
#include <varargs.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include "ebs.h"

u_char	xbuf[XBUFSIZE];
int	xcnt;
u_char	*xbp = xbuf;

/*
 *  0x21xx ʸȾʸѴ뤿Υơ֥
 */
u_char	tbl_21han[] = {
      /*   0     1     2     3     4     5     6     7  */
      /*   8     9     a     b     c     d     e     f  */
	 0xff,  ' ', 0xa4, 0xa1,  ',',  '.', 0xa5,  ':',	/* 0x20 */
	  ';',  '?',  '!', 0xde, 0xdf, '\'',  '`',0xff,		/* 0x28 */
	  '^',  '~', 0xff, 0xff, 0xff, 0xff,  '`', '\'',	/* 0x30 */
	 0xff, 0xff, 0xff, 0xff,  '-',  '-',  '-',  '/',	/* 0x38 */
         '\\',  '~', 0xff, 0xff, 0xff, 0xff,  '`', '\'',	/* 0x40 */
	  '"',  '"',  '(',  ')',  '[',  ']',  '[',  ']',	/* 0x48 */
	  '{',  '}',  '<',  '>', 0xff, 0xff, 0xa2, 0xa3,	/* 0x50 */
	 0xff, 0xff, 0xff, 0xff,  '+',  '-', 0xff, 0xff,	/* 0x58 */
	 0xff,  '=', 0xff,  '<',  '>', 0xff, 0xff, 0xff,	/* 0x60 */
	 0xff, 0xff, 0xff, 0xff, '\'',  '"', 0xff, 0xff,	/* 0x68 */
	  '$', 0xff, 0xff,  '%',  '#',  '&',  '*',  '@',	/* 0x70 */
	 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	/* 0x78 */
};
/*
 *  0x23xx ʸȾʸѴ뤿Υơ֥
 */
u_char	tbl_23han[] = {
      /*   0     1     2     3     4     5     6     7  */
      /*   8     9     a     b     c     d     e     f  */
	 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	/* 0x20 */
	 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	/* 0x28 */
	  '0',  '1',  '2',  '3',  '4',  '5',  '6',  '7',	/* 0x30 */
	  '8',  '9', 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	/* 0x38 */
	 0xff,  'A',  'B',  'C',  'D',  'E',  'F',  'G',	/* 0x40 */
	  'H',  'I',  'J',  'K',  'L',  'M',  'N',  'O',	/* 0x48 */
	  'P',  'Q',  'R',  'S',  'T',  'U',  'V',  'W',	/* 0x50 */
	  'X',  'Y',  'Z', 0xff, 0xff, 0xff, 0xff, 0xff,	/* 0x58 */
	 0xff,  'a',  'b',  'c',  'd',  'e',  'f',  'g',	/* 0x60 */
	  'h',  'i',  'j',  'k',  'l',  'm',  'n',  'o',	/* 0x68 */
	  'p',  'q',  'r',  's',  't',  'u',  'v',  'w',	/* 0x70 */
	  'x',  'y',  'z', 0xff, 0xff, 0xff, 0xff, 0xff,	/* 0x78 */
};
/*
 *  0x24xx, 0x25xx ѤʸȾѤʸѴ뤿Υơ֥
 */
u_char	tbl_kana2han[] = {
      /*   0     1     2     3     4     5     6     7  */
      /*   8     9     a     b     c     d     e     f  */
	 0xff, 0xa7, 0xb1, 0xa8, 0xb2, 0xa9, 0xb3, 0xaa,	/* 0x20 */
	 0xb4, 0xab, 0xb5, 0xb6, 0xff, 0xb7, 0xff, 0xb8,	/* 0x28 */
	 0xff, 0xb9, 0xff, 0xba, 0xff, 0xbb, 0xff, 0xbc,	/* 0x30 */
	 0xff, 0xbd, 0xff, 0xbe, 0xff, 0xbf, 0xff, 0xc0,	/* 0x38 */
	 0xff, 0xc1, 0xff, 0xaf, 0xc2, 0xff, 0xc3, 0xff,	/* 0x40 */
	 0xc4, 0xff, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9, 0xca,	/* 0x48 */
	 0xff, 0xff, 0xcb, 0xff, 0xff, 0xcc, 0xff, 0xff,	/* 0x50 */
	 0xcd, 0xff, 0xff, 0xce, 0xff, 0xff, 0xcf, 0xd0,	/* 0x58 */
	 0xd1, 0xd2, 0xd3, 0xac, 0xd4, 0xad, 0xd5, 0xae,	/* 0x60 */
	 0xd6, 0xd7, 0xd8, 0xd9, 0xda, 0xdb, 0xff, 0xdc,	/* 0x68 */
	 0xff, 0xff, 0xa6, 0xdd, 0xff, 0xff, 0xff, 0xff,	/* 0x70 */
	 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	/* 0x78 */
};

/*
 *
 */
isjis(str, buf)
	u_char *str;
	u_short *buf;
{
	int	c, c1, jis, inkanji;
	u_short *dp;

	inkanji = 0;
	jis = 0;
	dp = buf;
	while (c = *str++) {
		if (c == 0x1b) {
			if (*str == '$' && (*(str + 1) == 'B' ||
					    *(str + 1) == 'J')) {
				inkanji = 1;
				str += 2;
				continue;
			}
			else if (*str == '(' && (*(str + 1) == 'B' ||
						 *(str + 1) == 'J')) {
				inkanji = 0;
				str += 2;
				continue;
			}
		}
		else if (c <= ' ')
			continue;
		if (inkanji) {
			if ((c1 = *str++) == 0)
				break;
			*dp++ = (c << 8) + c1;
			jis = 1;
		}
	}
	*dp = 0;
	return jis;
}

/*
 *   JISѤcharʸEUCʸѴmallocΰ˥ԡ
 */
u_char *
toeuc(str, max)
	u_char *str;
{
	int	len;
	u_char	*p = str;

	while (*p && p < str + max) {
		*p++ |= 0x80;
		*p++ |= 0x80;
	}
	len = p - str;
	p = (u_char *)xmalloc(len + 1);
	bcopy(str, p, len);
	p[len] = 0;
	return p;
}

/*
 *   JIS1ʸȾʸѴ
 */
zen2han(hi, lo)
{
	u_char	c;

	if (lo < 0x21 || lo > 0x7f)
		return -1;
	if (hi == 0x21)
		c = tbl_21han[lo - 0x20];
	else if (hi == 0x23)
		c = tbl_23han[lo - 0x20];
	else if (hi == 0x24 || hi == 0x25)
		c = tbl_kana2han[lo - 0x20];
	else
		return -1;
	if (c == 0xff)
		return -1;
#ifndef HALFKANA
	if (c > 0x7f)
		return -1;
#endif
	return c;
}

/*
 *   ȾʸʸؤѴơ֥
 */
u_short	tbl_han2zen[] = {
	/*   0,      1,      2,      3,      4,      5,      6,      7	*/
	/*   8,      9,      a,      b,      c,      d,      e,      f	*/

	/*  ' '      !       "       #       $       %       &       ' */
	0x2121, 0x212a, 0x2149, 0x2174, 0x2170, 0x2173, 0x2175, 0x2147, /* 20 */
	/*   (       )       *       +       ,       -       .       / */
	0x214a, 0x214b, 0x2176, 0x215c, 0x2124, 0x215d, 0x2125, 0x213f, /* 28 */
	/*   0       1       2       3       4       5       6       7 */
	0x2330, 0x2331, 0x2332, 0x2333, 0x2334, 0x2335, 0x2336, 0x2337, /* 30 */
	/*   8       9       :       ;       <       =       >       ? */
	0x2338, 0x2339, 0x2127, 0x2128, 0x2152, 0x2161, 0x2153, 0x2129, /* 38 */
	/*   @       A       B       C       D       E       F       G */
	0x2177, 0x2341, 0x2342, 0x2343, 0x2344, 0x2345, 0x2346, 0x2347, /* 40 */
	/*   H       I       J       K       L       M       N       O */
	0x2348, 0x2349, 0x234a, 0x234b, 0x234c, 0x234d, 0x234e, 0x234f, /* 48 */
	/*   P       Q       R       S       T       U       V       W */
	0x2350, 0x2351, 0x2352, 0x2353, 0x2354, 0x2355, 0x2356, 0x2357, /* 50 */
	/*   X       Y       Z       [       \       ]       ^       _ */
	0x2358, 0x2359, 0x235a, 0x214e, 0x216f, 0x214f, 0x2130, 0x2132, /* 58 */
	/*   `       a       b       c       d       e       f       g */
	0x212e, 0x2361, 0x2362, 0x2363, 0x2364, 0x2365, 0x2366, 0x2367, /* 60 */
	/*   h       i       j       k       l       m       n       o */
	0x2368, 0x2369, 0x236a, 0x236b, 0x236c, 0x236d, 0x236e, 0x236f, /* 68 */
	/*   p       q       r       s       t       u       v       w */
	0x2370, 0x2371, 0x2372, 0x2373, 0x2374, 0x2375, 0x2376, 0x2377, /* 70 */
	/*   x       y       z       {       |       }       ~     DEL */
	0x2378, 0x2379, 0x237a, 0x2150, 0x2143, 0x2151, 0x2132, 0x2222, /* 78 */
};

/*
 *   u_charȾʸ󤫤code˱u_shortʸѴ
 *	code : CD_JIS, CD_EUC, CD_SJIS
 */
han2zen(han, zen, code)
	u_char	*han;
	u_short	*zen;
{
	int	c;
	int	inkanji = 0;

	switch (code) {
	case CD_JIS:
		while (c = *han++) {
			if (c == 0x33) {
				if (*han && *han == '$' && han[1]) {
					if (han[1] == '@' || han[1] == 'B') {
						inkanji = 1;
						han += 2;
					}
				}
				else if (*han && *han == '(' && han[1]) {
					if (han[1] == 'B' || han[1] == 'J') {
						inkanji = 0;
						han += 2;
					}
				}
				continue;
			}
			if (inkanji) {
				if (*han)
					*zen++ = (c << 8) + *han++;
				continue;
			}
			if (c >= 0x21 && c < 0x7f)
				*zen++ = tbl_han2zen[c - 0x20];
			else if (c >= 0xa1 && *han)
				*zen++ = ((c & 0x7f) << 8) + (*han++ & 0x7f);
		}
		break;
	case CD_EUC:
		while (c = *han++) {
			if (c >= 0x21 && c < 0x7f)
				*zen++ = tbl_han2zen[c - 0x20];
			else if (c >= 0xa1 && *han)
				*zen++ = ((c & 0x7f) << 8) + (*han++ & 0x7f);
			else if (c == 0x8e && *han)
				han++;		/* ignore hankaku-kana */
		}
		break;
	case CD_SJIS:
		while (c = *han++) {
			if (c >= 0x21 && c < 0x7f)
				*zen++ = tbl_han2zen[c - 0x20];
			if (c >= 0x81 && *han >= 0x40)
				*zen++ = stoj((c << 8) + *han++);
		}
		break;
	}
	*zen = 0;
}

/*
 *   u_shortʸʸ(ѻʡ¾)Ƚ
 */
get_chartype(str)
	u_short *str;
{
	int	c, hi;
	int	val = 0;

	while (c = *str++) {
		hi = c >> 8;
		if (hi == 0x23)
			val |= CT_ALPHA;
		else if (hi == 0x24 || hi == 0x25)
			val |= CT_KANA;
		else if (hi >= 0x30)
			val |= CT_KANJI;
		else if (c != 0x213c)		/* chouon kigou */
			val |= CT_OTHER;
	}
	return val;
}

/*
 *   ѤҤ餬ѥơ֥
 */
u_char	tbl_hira2sei[] = {
      /*   0     1     2     3     4     5     6     7  */
      /*   8     9     a     b     c     d     e     f  */
	 0xff, 0x22, 0x22, 0x24, 0x24, 0x26, 0x26, 0x28,	/* 0x20 */
	 0x28, 0x2a, 0x2a, 0x2b, 0x2b, 0x2d, 0x2d, 0x2f,	/* 0x28 */
	 0x2f, 0x31, 0x31, 0x33, 0x33, 0x35, 0x35, 0x37,	/* 0x30 */
	 0x37, 0x39, 0x39, 0x3b, 0x3b, 0x3d, 0x3d, 0x3f,	/* 0x38 */
	 0x3f, 0x41, 0x41, 0x44, 0x44, 0x44, 0x46, 0x46,	/* 0x40 */
	 0x48, 0x48, 0x4a, 0x4b, 0x4c, 0x4d, 0x4e, 0x4f,	/* 0x48 */
	 0x4f, 0x4f, 0x52, 0x52, 0x52, 0x55, 0x55, 0x55,	/* 0x50 */
	 0x58, 0x58, 0x58, 0x5b, 0x5b, 0x5b, 0x5e, 0x5f,	/* 0x58 */
	 0x60, 0x61, 0x62, 0x64, 0x64, 0x66, 0x66, 0x68,	/* 0x60 */
	 0x68, 0x69, 0x6a, 0x6b, 0x6c, 0x6d, 0x6f, 0x6f,	/* 0x68 */
	 0x70, 0x71, 0x72, 0x73, 0xff, 0xff, 0xff, 0xff,	/* 0x70 */
	 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	/* 0x78 */
};

/*
 *   ѥѥơ֥
 */
u_char	tbl_kata2sei[] = {
      /*   0     1     2     3     4     5     6     7  */
      /*   8     9     a     b     c     d     e     f  */
	 0xff, 0x22, 0x22, 0x24, 0x24, 0x26, 0x26, 0x28,	/* 0x20 */
	 0x28, 0x2a, 0x2a, 0x2b, 0x2b, 0x2d, 0x2d, 0x2f,	/* 0x28 */
	 0x2f, 0x31, 0x31, 0x33, 0x33, 0x35, 0x35, 0x37,	/* 0x30 */
	 0x37, 0x39, 0x39, 0x3b, 0x3b, 0x3d, 0x3d, 0x3f,	/* 0x38 */
	 0x3f, 0x41, 0x41, 0x44, 0x44, 0x44, 0x46, 0x46,	/* 0x40 */
	 0x48, 0x48, 0x4a, 0x4b, 0x4c, 0x4d, 0x4e, 0x4f,	/* 0x48 */
	 0x4f, 0x4f, 0x52, 0x52, 0x52, 0x55, 0x55, 0x55,	/* 0x50 */
	 0x58, 0x58, 0x58, 0x5b, 0x5b, 0x5b, 0x5e, 0x5f,	/* 0x58 */
	 0x60, 0x61, 0x62, 0x64, 0x64, 0x66, 0x66, 0x68,	/* 0x60 */
	 0x68, 0x69, 0x6a, 0x6b, 0x6c, 0x6d, 0x6f, 0x6f,	/* 0x68 */
	 0x70, 0x71, 0x72, 0x73, 0x26, 0x2b, 0x31, 0xff,	/* 0x70 */
	 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	/* 0x78 */
};

/*
 *   Ĺѥơ֥
 */
u_char	tbl_cho2sei[] = {
      /*   0     1     2     3     4     5     6     7  */
      /*   8     9     a     b     c     d     e     f  */
	 0xff, 0x22, 0x22, 0x24, 0x24, 0x26, 0x26, 0x28,	/* 0x20 */
	 0x28, 0x2a, 0x2a, 0x22, 0x22, 0x24, 0x24, 0x26,	/* 0x28 */
	 0x26, 0x28, 0x28, 0x2a, 0x2a, 0x22, 0x22, 0x24,	/* 0x30 */
	 0x24, 0x26, 0x26, 0x28, 0x28, 0x2a, 0x2a, 0x22,	/* 0x38 */
	 0x22, 0x24, 0x24, 0x26, 0x26, 0x26, 0x28, 0x28,	/* 0x40 */
	 0x2a, 0x2a, 0x22, 0x24, 0x26, 0x28, 0x2a, 0x22,	/* 0x48 */
	 0x22, 0x22, 0x24, 0x24, 0x24, 0x26, 0x26, 0x26,	/* 0x50 */
	 0x28, 0x28, 0x28, 0x2a, 0x2a, 0x2a, 0x22, 0x24,	/* 0x58 */
	 0x26, 0x28, 0x2a, 0x22, 0x22, 0x26, 0x26, 0x2a,	/* 0x60 */
	 0x2a, 0x22, 0x24, 0x26, 0x28, 0x2a, 0x22, 0x22,	/* 0x68 */
	 0x24, 0x28, 0x2a, 0x73, 0x26, 0x22, 0x28, 0xff,	/* 0x70 */
	 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	/* 0x78 */
};

/*
 *   u_shortʸ
 */
to_seion(src, dst)
	u_short	*src;
	u_short	*dst;
{
	int	c, hi, lo;
	u_short	*dp = dst;

	while (c = *src++) {
		hi = c >> 8;
		lo = c & 0xff;
		if (hi >= 0x21 && hi < 0x7f) {
			if (hi == 0x23)			/* alpha num */
				*dp++ = 0x2300 + toupper(lo & 0x7f);
			else if (hi == 0x24)		/* hiragana */
				*dp++ = 0x2400 + tbl_hira2sei[lo - 0x20];
			else if (hi == 0x25)		/* katakana */
				*dp++ = 0x2400 + tbl_kata2sei[lo - 0x20];
			else if (c == 0x213c) {
				if (dp == dst)
					continue;
				c = tbl_cho2sei[(dp[-1] & 0x7f) - 0x20];
				*dp++ = 0x2400 + c;
			}
		}
		else
			fprintf(stderr, "to_seion: bad code 0x%04x\n", c);
	}
	*dp = 0;
}

/*
 *   ɽʸѴ(ѱѾʸѱʸѴ)
 */
to_hyouki(src, dst)
	u_short	*src;
	u_short	*dst;
{
	int	c;

	while (c = *src++) {
		if ((c >> 8) == 0x23)
			*dst++ = 0x2300 + toupper(c & 0x7f);
		else
			*dst++ = c;
	}
	*dst = 0;
}

/*
 *   ޻ʸѴ
 *
 *	code = RK_KATA: ʤѴ
 *	code = RK_HIRA: Ҥ餬ʤѴ
 */
roma_kana(roma, kana, code)
	u_char	*roma;
	u_short	*kana;
{
	int	c, c1, hi, size, fail, hcode;
	u_char	*cp, *savep;
	struct	romatbl *tp;

	fail = 0;
	hcode = code == RK_KATA ? 0x2500 : 0x2400;
	while (c = *roma++) {
		if (c >= 0xa1 && *roma) {
			*kana++ = ((c & 0x7f) << 8) + (*roma++ & 0x7f);
			continue;
		}
		if (c == '-') {
			*kana++ = 0x213c;
			continue;
		}
		c1 = tolower(c);
		if (c1 != 'a' && c1 != 'i' && c1 != 'u' &&
		    c1 != 'e' && c1 != 'o' && c1 != 'n') {
			if (c == *roma) {
				*kana++ = hcode + 0x43;	/* small tu */
				roma++;
			}
		}
		c1 = c;
		savep = roma;
		tp = romatbl;
		size = rmtblsize;
		while (size > 0) {
			if (tp->ch == c1) {
				if (tp->size > 0) {
					if ((c1 = *roma) == 0) {
						size = 0;
						break;
					}
					roma++;
					size = tp->size;
					tp = tp->next;
					continue;
				}
				cp = (u_char *)tp->next;
				while (*cp) {
					if (code == RK_KATA)
						hi = 0x2500;
					else
						hi = (*cp & 0x7f) << 8;
					*kana++ = hi + (cp[1] & 0x7f);
					cp += 2;
				}
				break;
			}
			tp++;
			size--;
		}
		if (size == 0) {
			if (c == 'n') {
				*kana++ = hcode + 0x73;		/* n */
				roma = savep;
				continue;
			}
			fail++;
		}
	}
	*kana = 0;
	return fail;
}

#define	MAXBUFLEN	2048

/*
 *   cmdp->fp Υե cmdp->code ΥѴ򤷤format
 */
eprintf(cmdp, fmt, va_alist)
	struct	command *cmdp;
	char	*fmt;
	va_dcl
{
	int	ret;
	va_list	ap;
	static char	buf[MAXBUFLEN];

	va_start(ap);
	ret = vsprintf(buf, fmt, ap);
	va_end(ap);
	eputs(buf, cmdp);
	return ret;
}

/*
 *   cmdp->fp Υե cmdp->code ΥѴ򤷤ƽ
 */
eputs(buf, cmdp)
	char	*buf;
	struct	command *cmdp;
{
	switch (cmdp->code) {
	default:
		fprintf(stderr, "eputs: bad code %d\n", cmdp->code);
	case CD_JIS:
		jisputs(buf, cmdp->fp);
		break;
	case CD_EUC:
		xputs(buf, cmdp->fp);
		break;
	case CD_SJIS:
		sjisputs(buf, cmdp->fp);
		break;
	}
}

/*
 *   buf (EUC)  JISɤǽ
 */
#define	KI	"\033$B"
#define	KO	"\033(B"
#define	SI	0xf
#define	SO	0xe

static int	inkanji, inkana;

jisputs(buf, fp)
	u_char	*buf;
	FILE	*fp;
{
	int	c;
	u_char	*s = buf;

	while (c = *s++) {
		if (c == 0x8e) {
			if (inkanji) {
				xputs(KO, fp);
				inkanji = 0;
			}
			if (inkana == 0) {
				xputc(SO, fp);
				inkana = 1;
			}
			xputc(*s++ & 0x7f, fp);
		}
		else if (c >= 0xa1) {
			if (inkana) {
				xputc(SI, fp);
				inkana = 0;
			}
			if (inkanji == 0) {
				xputs(KI, fp);
				inkanji = 1;
			}
			xputc(c & 0x7f, fp);
			xputc(*s++ & 0x7f, fp);
		}
		else {
			if (inkana) {
				xputc(SI, fp);
				inkana = 0;
			}
			if (inkanji) {
				xputs(KO, fp);
				inkanji = 0;
			}
			xputc(c, fp);
		}
	}
}

/*
 *   buf (EUC)  SJIS ɤǽ
 */
sjisputs(buf, fp)
	u_char	*buf;
	FILE	*fp;
{
	int	c;
	u_short	code;
	u_char	*s = buf;

	while (c = *s++) {
		if (c == 0x8e && *s)
			xputc(*s++, fp);
		else if (c >= 0xa1 && *s) {
			code = jtos(((c & 0x7f) << 8) | (*s++ & 0x7f));
			xputc(code >> 8, fp);
			xputc(code & 0xff, fp);
		}
		else
			xputc(c, fp);
	}
}

/*
 *   JIS -> SJIS Ѵ
 */
jtos(code)
	unsigned int code;
{
	register unsigned int	hi, hi0, lo;

	hi0 = code >> 8;
	hi  = hi0 >> 1;
	lo  = (code + 0x1f) & 0xff;
	if ((hi0 & 1) == 0) {
		hi--;
		lo += 0x5e;
	}
	if (lo >= 0x7f)
		lo++ ;
	if (hi <= 0x2e)
		hi += 0x71;
	else
		hi += 0xb1;
	return((hi << 8) + lo);
}

/*
 *   SJIS -> JIS Ѵ
 */
stoj(code)
	unsigned int code;
{
	register unsigned int	hi, lo;

	hi = code >> 8;
	lo = code & 0xff;
	if (hi == 0x80)
		return(code);
	else if (hi < 0xa0)
		hi -= 0x70;
	else if (hi < 0xf0)
		hi -= 0xb0;
	else
		return((hi << 8) + lo);
	if (lo >= 0x80)
		lo--;
	hi += hi;
	if (lo >= 0x9e)
		lo -= 0x5e;
	else
		hi--;
	lo -= 0x1f;
	return((hi << 8) + lo);
}

xprintf(fp, fmt, va_alist)
	FILE	*fp;
	char	*fmt;
	va_dcl
{
	int	ret;
	va_list	ap;
	static char	buf[MAXBUFLEN];

	va_start(ap);
	ret = vsprintf(buf, fmt, ap);
	va_end(ap);
	xputs(buf, fp);
	return ret;
}

xputs(buf, fp)
	u_char	*buf;
	FILE	*fp;
{
	int	c, cnt;
	u_char	*cp, *bp;

	cnt = xcnt;
	cp = buf;
	bp = xbp;
	while (c = *cp++) {
		*bp++ = c;
		if (++cnt >= XBUFSIZE) {
			xcnt = cnt;
			xbp = bp;
			xflush(fp);
			bp = xbuf;
			cnt = 0;
		}
	}
	xcnt = cnt;
	xbp = bp;
}

xwrite(buf, size, n, fp)
	u_char	*buf;
	FILE	*fp;
{
	int	i, j;

	for (i = 0; i < n; i++)
		for (j = 0; j < size; j++)
			xputc(*buf++, fp);
	return n;
}

xflush(fp)
	FILE	*fp;
{
	int	cnt = xcnt;
	int	f, cc;
	u_char	*bp;

	if (cnt == 0)
		return;

	f = fileno(fp);
	bp = xbuf;

	while (cnt > 0) {
		if ((cc = write(f, bp, cnt)) < 0) {
			if (errno != EINTR) {
				perror("xflush: write");
				exit(1);
			}
			cc = 0;
		}
		cnt -= cc;
		bp += cc;
	}
	xcnt = 0;
	xbp = xbuf;
}
