/*
 * Copyright (c) 1994,1996 Noriyuki Shiota.  All rights reserved.
 *
 * $Id: main.c,v 1.7 1997/05/23 16:08:24 root Exp $
 */
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <signal.h>
#include <netdb.h>
#include <unistd.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
#include "ebs.h"
#include "format.h"

#ifdef	DEBUG
int	ftrace = 1;
#define	FPR(x)	(ftrace ? printf x : 0)
#else
#define	FPR(x)
#endif

int	debug;
FILE	*logfp;
int	romaform;

#define	LINESIZE	2048
static	u_char	linebuf[LINESIZE];

#ifndef __linux__
void
on_sigchild()
{
	while (waitpid(-1, NULL, WNOHANG) > 0)
		;
}
#endif /* !__linux__ */

main(argc, argv)
	char	**argv;
{
	int	s, f, c, len;
	pid_t	pid;
	struct	servent *srv, service;
	struct	sockaddr_in local, remote;
	fd_set	rfs;
	extern	char *optarg;
	extern	int optind;

	while ((c = getopt(argc, argv, "rk:dl:")) != EOF) {
		switch (c) {
#ifdef DEBUG
		case 'k':
			roma_kana(optarg, linebuf, RK_HIRA);
			fprintkey(stderr, linebuf);
			putc('\n', stderr);
			exit(0);
#endif
		case 'r':
			romaform++;
			break;
		case 'd':
			debug++;
			break;
		case 'l':
			if ((logfp = fopen(optarg, "a")) == NULL) {
				perror(optarg);
				exit(1);
			}
			break;
		case '?':
		default:
			goto fail;
		}
	}
	if (argc != optind) {
fail:
		fprintf(stderr, "usage: %s [-dr]\n", argv[0]);
		exit(1);
	}

	/*
	 *   CD-ROM Ϣν:
	 *     ebw3.conf ɤŻҥ֥åɤåǡ
	 *     롣
	 */
	initialize();

	if (debug == 0) {
		/*
		 *   debug modeǤʤbackground˲
		 *    control terminal ʤơ顼å
		 *   syslog ȤäƽϤ褦ˤ٤äƤʤ
		 */
#ifdef __linux__
		signal(SIGCHLD, SIG_IGN);
#else /* !__linux__ */
		signal(SIGCHLD, on_sigchild);
#endif /* !__linux__ */
#ifndef DEBUG
		if ((pid = fork()) == -1) {
			perror("fork");
			exit(1);
		}
		if (pid)
			exit(0);
#endif
	}

	/*
	 *   ͥåȥϢΤޤν
	 */
	if ((s = socket(PF_INET, SOCK_STREAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}
	c = 1;
	if (setsockopt(s, SOL_SOCKET, SO_REUSEADDR, &c, sizeof(c)) == -1) {
		perror("setsockopt");
		exit(1);
	}
	if ((srv = getservbyname("ebsp", "tcp")) == NULL) {
		service.s_port = htons(EBSP_DEFAULT_PORT);
		srv = &service;
	}
	bzero(&local, sizeof(local));
#if defined(__NetBSD__) || defined(__bsdi__) || defined(__FreeBSD__)
	/*  Net/2 ʹߤ sockaddr ξ */
	local.sin_len = sizeof(local);
#endif
	local.sin_family = AF_INET;
	local.sin_port = srv->s_port;
	if (bind(s, (struct sockaddr *)&local, sizeof(local)) == -1) {
		perror("bind");
		exit(1);
	}
	if (listen(s, 2) == -1) {
		perror("listen");
		exit(1);
	}
	for (;;) {
#ifdef MALLOC_DEBUG
		fprintf(stderr, "sbrk(0) = 0x%x\n", sbrk(0));
#endif
		/*
		 *   ׵Ԥ
		 */
		FD_ZERO(&rfs);
		FD_SET(s, &rfs);
		if (select(s + 1, &rfs, NULL, NULL, NULL) == -1) {
			if (errno == EINTR)
				continue;
			perror("select");
			exit(1);
		}
		/*
		 *   ׵դ
		 */
		len = sizeof(remote);
		if ((f = accept(s, (struct sockaddr *)&remote, &len)) == -1) {
			perror("accept");
			exit(1);
		}
		if (debug == 0) {
			while ((pid = fork()) == -1)
				sleep(300);
			if (pid == 0) {
				do_command(f, &remote);
				exit(0);
			}
			close(f);
		}
		else
			do_command(f, &remote);
	}
}

/*
 *   饤ȤΥޥɤɤߤȤparse
 */
do_command(f, remote)
	struct sockaddr_in *remote;
{
	int	i, hi, lo, ac, len, val;
	FILE	*fp;
	struct	command cmd;
	u_char	path[P_PATHMAX];
	u_char	key[P_KEYLEN];

	FPR(("do_command(%d)\n", f));
	if ((fp = fdopen(f, "r")) == NULL) {
		perror("fdopen");
		return;
	}
	/*
	 *   command¤Τν
	 */
	bzero(&cmd, sizeof(cmd));
	strcpy(path, "/");
	bzero(key, P_KEYLEN);
	cmd.fp = fp;
	cmd.path = path;
	cmd.cpath = path;
	cmd.key = key;
	cmd.code = CD_UNDEF;
	cmd.fontsize = DEFAULT_FONTSIZE;
	cmd.index = WD_UNSPEC;
	/*
	 *   EOFԤޤparsecommand¤Τͤ򥻥åȤ
	 */
	while (fgets(linebuf, LINESIZE, fp) != NULL) {
		/* CR/LF ɤФ */
		len = strlen(linebuf);
		if (len > 0 && linebuf[len - 1] == '\n')
			linebuf[--len] = 0;
		if (len > 0 && linebuf[len - 1] == '\r')
			linebuf[--len] = 0;
		if (len == 0)			/* Ԥʤ齪 */
			break;
		if (strncmp("path=", linebuf, 5) == 0) {
			if (strlen(&linebuf[5]) > P_PATHMAX - 1)
				return;
			strcpy(cmd.path, &linebuf[5]);
		}
		else if (strncmp("fontsize=", linebuf, 9) == 0)
			cmd.fontsize = atoi(&linebuf[9]);
		else if (strncmp("key=", linebuf, 4) == 0) {
			if (strlen(&linebuf[4]) > P_KEYLEN - 1)
				return;
			strcpy(cmd.key, &linebuf[4]);
		}
		else if (strncmp("code=", linebuf, 5) == 0) {
			if (strcmp(&linebuf[5], "jis") == 0)
				cmd.code = CD_JIS;
			else if (strcmp(&linebuf[5], "euc") == 0)
				cmd.code = CD_EUC;
			else if (strcmp(&linebuf[5], "sjis") == 0)
				cmd.code = CD_SJIS;
		}
		else if (strncmp("type=", linebuf, 5) == 0) {
			if (strcmp(&linebuf[5], "exact") == 0)
				cmd.type = SD_EXACT;
			else if (strcmp(&linebuf[5], "forw") == 0)
				cmd.type = SD_FORW;
			else if (strcmp(&linebuf[5], "back") == 0)
				cmd.type = SD_BACK;
		}
		else if (strncmp("index=", linebuf, 6) == 0) {
			if (strcmp(&linebuf[6], "kana") == 0)
				cmd.index = WD_KANA;
			else if (strcmp(&linebuf[6], "hyouki") == 0)
				cmd.index = WD_HYOUKI;
			else if (strcmp(&linebuf[6], "alpha") == 0)
				cmd.index = WD_ALPHA;
			else if (strcmp(&linebuf[6], "kanji") == 0)
				cmd.index = WD_KANJI;
		}
		else if (strncmp("romkana=", linebuf, 8) == 0) {
			if (strcmp(&linebuf[8], "no") == 0 ||
			    strcmp(&linebuf[8], "false") == 0)
				cmd.romkana = RK_NONE;
			else if (strcmp(&linebuf[8], "hira") == 0)
				cmd.romkana = RK_HIRA;
			else if (strcmp(&linebuf[8], "kata") == 0)
				cmd.romkana = RK_KATA;
		}
		else if (strncmp("disp=", linebuf, 5) == 0) {
			if (strcmp(&linebuf[5], "item") == 0)
				cmd.dispitem = 1;
			else
				cmd.dispitem = 0;
		}
		else if (strncmp("url=", linebuf, 4) == 0)
			cmd.url = strdup(&linebuf[4]);
		else if (linebuf[0] == 'k' &&
			 (val = sscanf(linebuf, "k%d=%s", &i, key)) >= 1) {
#ifndef COMPLEX_CONDITION
			if (i >= COND_N_NODE) {
		bad_val:
				fprintf(stderr, "%s: bad index\n", linebuf);
				return;
			}
			cmd.condnode[i].key = val == 1 ? NULL : strdup(key);
#else
			hi = i / 10, lo = i % 10;
			if (hi >= COND_N_NODE || lo >= COND_N_LEAF) {
		bad_val:
				fprintf(stderr, "%s: bad index\n", linebuf);
				return;
			}
			cmd.condnode[hi].condleaf[lo].key =
				val == 1 ? NULL : strdup(key);
#endif
		}
		else if (linebuf[0] == 'n' &&
			 sscanf(linebuf, "n%d=%s", &i, key) == 2) {
#ifndef COMPLEX_CONDITION
			if (i >= COND_N_NODE)
				goto bad_val;
			cmd.condnode[i].not = key[0] == 'f';
#else
			hi = i / 10, lo = i % 10;
			if (hi >= COND_N_NODE || lo >= COND_N_LEAF)
				goto bad_val;
			cmd.condnode[hi].condleaf[lo].not = key[0] == 'f';
#endif
		}
		else if (linebuf[0] == 'r' &&
			 sscanf(linebuf, "r%d=%s", &hi, key) == 2) {
#ifndef COMPLEX_CONDITION
			if (hi >= COND_N_NODE)
				goto bad_val;
			if (key[0] == 'n')
				i = RK_NONE;
			else if (key[0] == 'h')
				i = RK_HIRA;
			else if (key[0] == 'k')
				i = RK_KATA;
			cmd.condnode[hi].roma = i;
#else
			hi = i / 10, lo = i % 10;
			if (hi >= COND_N_NODE || lo >= COND_N_LEAF)
				goto bad_val;
			if (key[0] == 'n')
				i = RK_NONE;
			else if (key[0] == 'h')
				i = RK_HIRA;
			else if (key[0] == 'k')
				i = RK_KATA;
			cmd.condnode[hi].condleaf[lo].roma = i;
#endif
		}
#ifdef COMPLEX_CONDITION
		else if (linebuf[0] == 'a' &&
			 sscanf(linebuf, "a%d=%s", &i, key) == 2) {
			hi = i / 10, lo = i % 10;
			if (hi >= COND_N_NODE || lo >= COND_N_LEAF)
				goto bad_val;
			if (key[0] == 'a')
				i = OP_AND;
			else if (key[0] == 'o')
				i = OP_OR;
			cmd.condnode[hi].condleaf[lo].op = i;
		}
		else if (linebuf[0] == 'o' &&
			 sscanf(linebuf, "o%d=%s", &hi, key) == 2) {
			if (hi >= COND_N_NODE)
				goto bad_val;
			if (key[0] == 'a')
				i = OP_AND;
			else if (key[0] == 'o')
				i = OP_OR;
			cmd.condnode[hi].op = i;
		}
#endif
		else
			fprintf(stderr, "%s: unknown query string\n", linebuf);
	}

	if (cmd.path != NULL) {
		if (do_path(&cmd) == -1)	/* ޥɼ¹ */
			do_error(&cmd);
	}
	else
		do_error(&cmd);

	xflush(fp);
	shutdown(f, 2);
	fclose(fp);
}

/*
 *   pathparse뤿˺ǽ˸ƤӽФ롼
 *
 *   path:	/jis/g0/...
 *		^ cpath
 */
do_path(cmdp)
	struct command *cmdp;
{
	int	dot = DEFAULT_GOFFSET;
	u_char	*cp;

	FPR(("do_path(%s)\n", cmdp->cpath));
	if (cmdp->cpath[0] != '/')
		return -1;

	/*
	 *   (jis/euc/sjis)Ф
	 */
	if (strncmp(cmdp->cpath, "/jis/", 5) == 0) {
		if (cmdp->code == CD_UNDEF)
			cmdp->code = CD_JIS;
		cmdp->cpath += 5;
	}
	else if (strncmp(cmdp->cpath, "/euc/", 5) == 0) {
		if (cmdp->code == CD_UNDEF)
			cmdp->code = CD_EUC;
		cmdp->cpath += 5;
	}
	else if (strncmp(cmdp->cpath, "/sjis/", 6) == 0) {
		if (cmdp->code == CD_UNDEF)
			cmdp->code = CD_SJIS;
		cmdp->cpath += 6;
	}
	if (cmdp->code == CD_UNDEF)
		cmdp->code = CD_JIS;

	if (strncmp(cmdp->cpath, "list/", 5) == 0)
		return do_list(cmdp);
	if (cmdp->cpath[0] == 'g') {
		/*
		 *   եåȤФ
		 */
		dot = strtol(cmdp->cpath + 1, (char **)&cp, 10);
		if (cp == cmdp->cpath + 1 || cp[0] != '/')
			return -1;
		cmdp->cpath = cp + 1;
		if (dot > MAX_GOFFSET)
			dot = MAX_GOFFSET;
	}
	cmdp->goff = dot;

	/*
	 *   server noФ
	 */
	if (!isdigit(cmdp->cpath[0]))
		return -1;
	cmdp->serverno = strtol(cmdp->cpath, (char **)&cp, 10);
	if (cp == cmdp->cpath || cp[0] != '/')
		return -1;
	cmdp->cpath = cp + 1;

	if (cmdp->cpath[0] == 0)
		return do_root(cmdp);	/* /{jis/{g0/}} ξ */

	return do_dict(cmdp);	/* /jis/g0/... ξ */
}

/*
 *   Home Page Ѥ html Ϥ
 *
 *	path:	"/jis/g2/<server-no>/"
 *				     ^ cpath
 */
do_root(cmdp)
	struct  command *cmdp;
{
	int	i;
	char	*cp = cmdp->path;
	struct disc *dc;

	FPR(("do_root(%s)\n", cmdp->path));
	/*
	 *   ޥȤƤƤŻҥ֥åˤĤưʲhtmlϤ
	 *
	 *	<LI> <A HREF={url}> Żҥ֥å̾ </A>\n
	 */
	for (dc = discp, i = 1; dc; dc = dc->dc_next) {
		if ((dc->dc_flags & DCF_VALID) == 0)
			continue;
		eprintf(cmdp, "<LI><A HREF=\"%s?path=%s%d/\">%s</A>\n",
			cmdp->url, cmdp->path, i, dc->dc_name);
		FPR(("<LI><A HREF=\"%s?path=%s%d/\">%s</A>\n",
			cmdp->url, cmdp->path, i, dc->dc_name));
		i++;
	}
	return 0;
}

/*
 *   Żҥ֥åǲץڡν
 *
 *	enter:	"/jis/g2/<server-no>/<disc-no>/"
 *				     ^ cpath
 */
static u_char	*dict_head = "\
Content-Type: text/html\n\n\
<HTML>\n<HEAD><TITLE>%s</TITLE></HEAD>\n\
<BODY>\n<H1>%s</H1>\n\
<P><HR><P>\n\
<H2>Żҥ֥åǤ</H2>\n\
<P>\n\
<UL>\n";

static u_char	*dict_tail = "\
</UL>\n\
<UL>\n<LI><A HREF=\"%s?path=/%s/g%d/\">Return</A></UL>\n\
<P><HR>\n\
</BODY>\n</HTML>";

do_dict(cmdp)
	struct	command *cmdp;
{
	long	n;
	u_char	*cp;
	struct disc *dc;
	struct dict *dt;

	/*
	 *   disc noڤФ
	 */
	if (!isdigit(cmdp->cpath[0]))
		return -1;
	n = strtol(cmdp->cpath, (char **)&cp, 10);
	if (cp == cmdp->cpath || cp[0] != '/')
		return -1;
	cmdp->cpath = cp + 1;

	/*
	 *   disc no˰פstruct discõ
	 */
	for (dc = discp; dc; dc = dc->dc_next) {
		if ((dc->dc_flags & DCF_VALID) == 0)
			continue;
		if (dc->dc_discno == n)
			break;
	}
	if (dc == NULL)
		return -1;

	/*
	 *   path³do_book()ǽ
	 */
	if (cmdp->cpath[0] != 0)
		return do_book(cmdp, dc);

	/*
	 *   Żҥ֥åǲץڡhtmlϤ
	 */
	eprintf(cmdp, dict_head, dc->dc_name, dc->dc_name);
	for (dt = dc->dc_dict; dt; dt = dt->dt_next)
		eprintf(cmdp, "<LI><A HREF=\"%s?path=%s%d/\">%s</A>\n",
			cmdp->url, cmdp->path, dt->dt_dictno, dt->dt_name);
	eprintf(cmdp, dict_tail, cmdp->url,
		cmdp->code == CD_EUC ? "euc" :
		cmdp->code == CD_SJIS ? "sjis" : "jis", cmdp->goff);
	return 0;
}

/*
 *   ֤Żҥ֥åǤϰʲθˡѤǤޤץڡν
 *
 *	enter:	"/jis/g2/<server-no>/<disc-no>/<dict-no>/"
 *				  	       ^ cpath
 */
static u_char	*book_head = "\
Content-Type: text/html\n\n\
<HTML>\n<HEAD><TITLE>%s</TITLE></HEAD>\n\
<BODY>\n<H1>%s</H1>\n\
<P><HR><P>\n\
<H2>Żҥ֥åǤϰʲθˡѤǤޤ</H2>\n\
<P>\n\
<UL>\n";

static u_char	*book_tail = "\
</UL>\n\
<UL>\n<LI><A HREF=\"%s?path=%s\">Return</A></UL>\n\
<P><HR>\n\
</BODY>\n</HTML>";

do_book(cmdp, dc)
	struct	command *cmdp;
	struct	disc *dc;
{
	int	n, i;
	struct	dict *dt;
	struct	toc *tp;
	struct	toctbl *tbp;
	struct	wordsrch *wp;
	u_char	*cp;

	/*
	 *   dict noڤФ
	 */
	if (!isdigit(cmdp->cpath[0]))
		return -1;
	n = strtol(cmdp->cpath, (char **)&cp, 10);
	if (cp == cmdp->cpath || cp[0] != '/')
		return -1;
	cmdp->cpath = cp + 1;

	/*
	 *   dict no˰פstruct dictõ
	 */
	for (dt = dc->dc_dict; dt; dt = dt->dt_next) {
		if (dt->dt_dictno == n)
			break;
	}
	if (dt == NULL)
		return -1;

	/*
	 *   path³do_toc()ǽ
	 */
	if (cmdp->cpath[0] != 0)
		return do_toc(cmdp, dt);

	/*
	 *    ˡڡhtmlϤ
	 */
	eprintf(cmdp, book_head, dt->dt_name, dt->dt_name);
	if (wp = dt->dt_word) {
		eprintf(cmdp, "<LI><A HREF=\"%s?path=%ssearch/\">",
			cmdp->url, cmdp->path);
		eprintf(cmdp, "ñ측 (%s)</A>\n", wp->ws_name);
	}
	for (tbp = toctbl; tbp->name; tbp++) {
		if ((tbp->flags & ST_MASK) == ST_WORD)
			continue;
		i = 0;
		for (tp = dt->dt_toc; tp; tp = tp->tc_next) {
			if (tp->tc_type != tbp->type)
				continue;
			i++;
			eprintf(cmdp, "<LI><A HREF=\"%s?path=%s%d/\">%s",
				cmdp->url, cmdp->path, tp->tc_tocno, tbp->name);
			if (tp->tc_flags & TCF_MULTI)
				eprintf(cmdp, "%c%c</A>\n", 0xa3, 0xb0 + i);
			else {
				eprintf(cmdp, "</A>\n");
				break;
			}
		}
	}
	eprintf(cmdp, book_tail, cmdp->url, return_path(cmdp));
	return 0;
}

/*
 *   ˡ˱ƤӽФ
 *
 *	enter:	"/jis/g2/<server-no>/<disc-no>/<dict-no>/WORD/"
 *				  	    	         ^ cpath
 *
 *	  WORD = <toc-no>, gaiji, fig, sound, color, search, csearch
 */
do_toc(cmdp, dt)
	struct	command *cmdp;
	struct	dict *dt;
{
	int	n, ret;
	u_char	*cp;
	struct	toc *tp;
	struct	toctbl *fup;

	/*
	 *   toc noǤʤν
	 */
	if (!isdigit(cmdp->cpath[0])) {
		if (strncmp(cmdp->cpath, "gaiji/", 6) == 0) {
			/* Υ */
			cmdp->cpath += 6;
			return do_gaiji(cmdp, dt);
		}
		if (strncmp(cmdp->cpath, "fig/", 4) == 0) {
			/* ޤλ */
			cmdp->cpath += 4;
			return do_fig(cmdp, dt, 0);
		}
		if (strncmp(cmdp->cpath, "bmpfig/", 7) == 0) {
			/* ޤλ */
			cmdp->cpath += 7;
			return do_fig(cmdp, dt, 1);
		}
		if (strncmp(cmdp->cpath, "sound/", 6) == 0) {
			/* λ(ݡȤƤʤ) */
			cmdp->cpath += 6;
			return do_sound(cmdp, dt);
		}
		if (strncmp(cmdp->cpath, "pcmsnd/", 7) == 0) {
			cmdp->cpath += 7;
			return do_pcmsound(cmdp, dt);
		}
		if (strncmp(cmdp->cpath, "color/", 6) == 0) {
			/* ܤλ(ݡȤƤʤ) */
			cmdp->cpath += 6;
			return do_color(cmdp, dt);
		}
		if (strncmp(cmdp->cpath, "search/", 7) == 0) {
			/* ñ측ڡ¹ */
			cmdp->cpath += 7;
			return do_search(cmdp, dt);
		}
		if (strncmp(cmdp->cpath, "csearch/", 8) == 0) {
			/* ︡ڡ¹ */
			cmdp->cpath += 8;
			return do_csearch(cmdp, dt);
		}
		return -1;
	}
	/*
	 *   toc noڤФ
	 */
	n = strtol(cmdp->cpath, (char **)&cp, 10);
	if (cp == cmdp->cpath || cp[0] != '/')
		return -1;
	cmdp->cpath = cp + 1;

	/*
	 *   toc nostruct toc
	 */
	for (tp = dt->dt_toc; tp; tp = tp->tc_next) {
		if (tp->tc_tocno == n)
			break;
	}
	if (tp == NULL)
		return -1;
	for (fup = toctbl; fup->name; fup++) {
		if (fup->type == tp->tc_type)
			break;
	}
	if (fup->name == NULL)
		return -1;

	/*
	 *   tocȤν¹
	 */
	return (*fup->func)(cmdp, tp);
}

do_list(cmdp)
	struct command *cmdp;
{
	int	discno;
	struct disc *dc;
	struct dict *dt;

	for (dc = discp, discno = 1; dc; dc = dc->dc_next) {
		if ((dc->dc_flags & DCF_VALID) == 0)
			continue;
		for (dt = dc->dc_dict; dt; dt = dt->dt_next) {
			eprintf(cmdp, "\"%s\" ", dc->dc_name);
			eprintf(cmdp, "\"%s\" ", dt->dt_name);
		}
	}
}

#define	ENVSIZE	40

char *
envstr(cmdp)
	struct command *cmdp;
{
	static char buf[ENVSIZE];

	sprintf(buf, "&type=%s&index=%s&romkana=%s%s",
		cmdp->type == SD_EXACT ? "exact" :
		cmdp->type == SD_FORW ? "forw" :
		cmdp->type == SD_BACK ? "back" : "exact",
		cmdp->index == WD_KANA ? "kana" :
		cmdp->index == WD_HYOUKI ? "hyouki" :
		cmdp->index == WD_ALPHA ? "alpha" :
		cmdp->index == WD_KANJI ? "kanji" : "hyouki",
		cmdp->romkana == RK_NONE ? "no" :
		cmdp->romkana == RK_HIRA ? "hira" :
		cmdp->romkana == RK_KATA ? "kata" : "no",
		cmdp->dispitem ? "&disp=item" : "");
	return buf;
}

do_error(cmdp)
	struct	command *cmdp;
{
	xputs("\n", cmdp->fp);
}
