/*
 * Copyright (c) 1994,1995 Noriyuki Shiota.  All rights reserved.
 *
 * $Id: search.c,v 1.7 1997/05/23 16:08:24 root Exp $
 */
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include "ebs.h"
#include "format.h"

#define	KEYLEN	128

struct entry	*do_index();
struct entry	*do_index_kana();
struct entry	*do_index_hyouki();
struct entry	*do_index_cond();
struct entry	*entry_sort();
struct entry	*entry_uniq();
struct entry	*entry_and_hon();
struct entry	*entry_and_not_hon();

static u_short keybuf[KEYLEN + 1];
static u_short keybuf1[KEYLEN + 1];
static u_short kbuf[KEYLEN + 1];

struct entry	*csearch();

#ifndef COMPLEX_CODITION
#else
struct cond	*cs_make_tree();
struct cond	*cs_make_node();
struct cond	*cs_make_leaf();
struct cond 	*cs_make_canon();
#endif

/*
 *   Фñ측
 *
 *	path:	"/jis/g2/<server-no>/<disc-no>/<dict-no>/search/..."
 *				  	    		        ^ cpath
 */
do_search(cmdp, dt)
	struct	command *cmdp;
	struct	dict *dt;
{
	int	type, ctype;
	struct	entry *ep;
	struct	toc *tp, **tpp;
	struct	wordsrch *wp = dt->dt_word;

	if (cmdp->key[0] == 0 && cmdp->cpath[0] == 0)
		return do_search_title(cmdp, dt);
	if (cmdp->cpath[0] != 0)
		return do_data(cmdp, dt);

	DPR((stderr, "path=%s, key=%s, ", cmdp->path, cmdp->key));

	if (cmdp->type == SD_FORW) {	/*  */
		DPR((stderr, "type=forw\n"));
		tpp = wp->ws_forw;
		type = TY_FORW;
	}
	else if (cmdp->type == SD_BACK) {	/*  */
		DPR((stderr, "type=back\n"));
		tpp = wp->ws_back;
		type = TY_BACK;
	}
	else {					/*  */
		DPR((stderr, "type=exact\n"));
		tpp = wp->ws_exact;
		type = TY_EXACT;
	}
	if (cmdp->key[0] == 0) {
		/*
		 *  pathꤷƤʤ
		 */
		do_search_title(cmdp, dt);
		return;
	}
	DPR((stderr, "key = %s\n", cmdp->key));
	if (isjis(cmdp->key, keybuf1) == 0) {
		if (cmdp->romkana == RK_HIRA || cmdp->romkana == RK_KATA) {
			/*
			 *  ޻ѴԤʤ
			 */
			if (roma_kana(cmdp->key, keybuf1, cmdp->romkana) != 0)
				/*
				 *   ޻Ѵ˼Ԥ
				 *   ΤޤJISɤѴ
				 */
				han2zen(cmdp->key, keybuf1, cmdp->code);
		}
		else {
			/*
			 *   ޻ѴꤵƤʤϡ
			 *   JISʸѴ
			 */
			han2zen(cmdp->key, keybuf1, cmdp->code);
		}
	}

	if (debug) {
		fprintf(stderr, "keybuf1 = ");
		fprintkey(stderr, keybuf1);
		putc('\n', stderr);
	}

	ctype = get_chartype(keybuf1);
	if (ctype == CT_KANA) {		/* keyʤξ */
		DPR((stderr, "KANA only\n"));
		if (tp = tpp[WD_KANA]) {  /* ʸѥǥå*/
			/* ʤ */
			to_seion(keybuf1, keybuf);
			if (debug) {
				fprintf(stderr, "to_seion = ");
				fprintkey(stderr, keybuf);
				putc('\n', stderr);
			}
		}
		else if (tp = tpp[WD_HYOUKI]) { /*ɽѥǥå*/
			/* ɽľ */
			to_hyouki(keybuf1, keybuf);
			if (debug) {
				fprintf(stderr, "to_hyouki = ");
				fprintkey(stderr, keybuf);
				putc('\n', stderr);
			}
		}
		else {
			do_search_title(cmdp, dt);
			return;
		}
	}
	else {				/* key ʰʳʸޤ */
		DPR((stderr, "not KANA\n"));
		if (cmdp->index == WD_UNSPEC)
			/* ǥåλ꤬ʤɽȤߤʤ */
			tp = tpp[WD_HYOUKI];
		else
			tp = tpp[cmdp->index];

		if (tp == NULL) {
			/* ꤵ줿ǥåʤϥ顼 */
			do_search_title(cmdp, dt);
			return;
		}
		/* ɽľ */
		to_hyouki(keybuf1, keybuf);
		if (debug) {
			fprintf(stderr, "to_hyouki = ");
			fprintkey(stderr, keybuf);
			putc('\n', stderr);
		}
	}
	if (cmdp->type == SD_BACK) {	/* ׸ξ */
		/* key ȿž */
		reverse_key(keybuf);
		reverse_key(keybuf1);
		if (debug) {
			fprintf(stderr, "reverse_key = ");
			fprintkey(stderr, keybuf);
			putc('\n', stderr);
		}
	}

	/*
	 *   Фñ측Ԥʤ
	 */
	ep = do_index(tp, cmdp, tp->tc_start, keybuf, keybuf1, NULL);

	if (ep == NULL) {
		/*
		 *   
		 */
		do_search_title(cmdp, tp->tc_dict);
		return;
	}
	/* ʸΰֽ˥ */
	ep = entry_sort(ep, SOT_HONMON | SOD_ASCEND);
	/* ʣ륨ȥ */
	ep = entry_uniq(ep, SOT_HONMON);

	/*
	 *   ̤html
	 */
	put_index_page(cmdp, tp, ep, keybuf1, type);
	/* ȥ */
	entries_free(ep);
}

/*
 *   ︡
 *
 *	path:	"/jis/g2/<server-no>/<disc-no>/<dict-no>/csearch/..."
 *				  	    		         ^ cpath
 */

#ifndef COMPLEX_CONDITON

do_csearch(cmdp, dt)
	struct	command *cmdp;
	struct	dict *dt;
{
	int	i;
	struct	toc *tp;
	struct	entry *entry, *ep;
	struct	condnode *p;
	/*
	 *   ︡ѥǥå뤫ǧ
	 */
	for (tp = dt->dt_toc; tp; tp = tp->tc_next)
		if (tp->tc_type == T_INDEX_COND)
			break;
	if (tp == NULL) {
		put_error(cmdp, "︡ΤΥǥåǡޤ");
		return;
	}

	/*
	 *  ֤ޤ׾Ǥθ
	 */
	entry = ALLENTRY;
	for (p = cmdp->condnode, i = 0; entry && i < COND_N_NODE; i++, p++) {
		if (p->not || p->key == NULL)
			continue;
		/* ¹ */
		ep = csearch(cmdp, tp, p);
		if (entry == ALLENTRY)
			/* ǽξʸΰֽ˥ */
			entry = entry_sort(ep, SOT_HONMON | SOD_ASCEND);
		else
			/* ¸ȥȤ AND  */
			entry = entry_and_hon(entry, ep);
		DPR((stderr, "do_csearch: entry num: %d\n", entry_len(entry)));
	}

	/*
	 *  ֤ޤޤʤ׾Ǥθ
	 */
	for (p = cmdp->condnode, i = 0; entry && i < COND_N_NODE; i++, p++) {
		if (p->not == 0 || p->key == NULL)
			continue;
		/* ¹ */
		ep = csearch(cmdp, tp, p);
		if (entry == ALLENTRY) {
			put_error(cmdp,
			     "ΤޤޤʤϾθϤǤޤ<BR>\n\
ΤޤϾƱ˻ꤷƸƲ");
			return;
		}
		/* ¸ȥ꤫鸡̤Υȥ */
		entry = entry_and_not_hon(entry, ep);
		DPR((stderr, "do_csearch: entry num: %d\n", entry_len(entry)));
	}
	if (entry == NULL) {
		put_error(cmdp, "ܤޤ");
		return;
	}

	i = entry_len(entry);
	DPR((stderr, "result = %d\n", i));
	/*
	 *   ̤htmlɽ
	 */
	put_index_page(cmdp, tp, entry, "condition search", TY_COND);
	entries_free(entry);
}

struct entry *
/*
 *   ︡¹
 */
csearch(cmdp, tp, p)
	struct	command *cmdp;
	struct	toc *tp;
	struct	condnode *p;
{
	u_short	*sp;
	struct	entry *ep;

	if (p->key == NULL)
		return NULL;

	DPR((stderr, "key = %s\n", p->key));
	sp = xmalloc(strlen(p->key) * sizeof(u_short));
	if (isjis(p->key, sp) == 0) {
		if (p->roma == RK_NONE) {
			/*
			 *   ޻ѴꤵƤʤϡ
			 *   JISʸѴ
			 */
			han2zen(p->key, sp, cmdp->code);
			to_hyouki(sp, sp);
		}
		else {
			/*
			 *  ޻ѴԤʤ
			 */
			if (roma_kana(p->key, sp, p->roma) != 0) {
				han2zen(p->key, sp, cmdp->code);
				to_hyouki(sp, sp);
			}
		}
	}

	if (debug) {
		fprintf(stderr, "KEY = ");
		fprintkey(stderr, sp);
		putc('\n', stderr);
	}

	if (usstrlen(sp) == 0) {
		xfree(sp);
		return NULL;
	}
	ep = do_index(tp, cmdp, tp->tc_start, sp, sp);
	xfree(sp);
	DPR((stderr, "csearch: retuns %d\n", entry_len(ep)));
	return ep;
}

#else /* COMPLEX_CONDITION */

do_csearch(cmdp, dt)
	struct	command *cmdp;
	struct	dict *dt;
{
	struct cond *p;

	if ((p = cs_make_tree(cmdp)) == NULL) {
		put_error(cmdp, "ϤƲ");
		return -1;
	}
	if (p->cond_op & COP_NOT_CLAUSE) {
		put_error(cmdp, "δޤޤʤϾθϤǤޤ");
		return -1;
	}
	if ((p = cs_make_canon(p, NULL)) {
		put_error(cmdp, "ɸؤѴ˼Ԥޤ");
		return -1;
	}
	entry = csearch(cmdp, dt, p, NULL);
}

struct entry *
csearch(cmdp, dt, p, ep)
	struct	command *cmdp;
	struct	dict *dt;
	struct cond *p;
	struct entry *ep;
{
	struct entry *ep1, *ep2;

	if (IS_CNODE(p)) {
		if (p->cond_right->cond_op & COP_NOT) {
			ep = csearch(cmdp, dt, p->cond_right, ep);
			ep = csearch(cmdp, dt, p->cond_left, ep);
			return ep;
		}
		ep = csearch(cmdp, dt, p->cond_left, ep);
		ep = csearch(cmdp, dt, p->cond_right, ep);
		return ep;
	}
}

struct cond *
cs_make_canon(p, p0)
	struct cond *p, *p0;
{
	struct cond *lp, *rp;

	if (IS_LEAF(p)) {
		if (p0 == NULL)
			return p;
		lp = xmalloc(sizeof(struct cond));
		lp->cond_op = COP_NODE | COP_AND;
		lp->cond_left = p;
		lp->cond_right = p0;
		return lp;
	}

	lp = p->cond_left;
	rp = p->cond_right;
	
}

struct cond *
cs_make_tree(cmdp)
	struct command *cmdp;
{
	int i;
	struct condnode *np;
	struct cond *lp, *rp, *p;

	lp = NULL;
	for (i = 0; i < COND_N_NODE; i++) {
		np = &cmdp->condnode[i];
		rp = cs_make_node(cmdp, np);
		if (rp == NULL)
			continue;
		if (lp == NULL) {
			lp = rp;
			continue;
		}
		p = xmalloc(sizeof(struct cond));
		if (np->op == OP_AND) {
			p->cond_op =  COP_NODE | COP_AND;
			if ((rp->cond_op & COP_NOT_CLAUSE) &&
			    (lp->cond_op & COP_NOT_CLAUSE))
				p->cond_op |= COP_NOT_CLAUSE;
		}
		else {
			p->cond_op =  COP_NODE | COP_OR;
			if ((rp->cond_op & COP_NOT_CLAUSE) &&
			    (lp->cond_op & COP_NOT_CLAUSE))
				p->cond_op |= COP_NOT_CLAUSE;
		}
		p->cond_left = lp;
		p->cond_right = rp;
		lp = p;
	}
	return lp;
}

struct cond *
cs_make_node(cmdp, np)
	struct command *cmdp;
	struct condnode *np;
{
	int i;
	struct condleaf *cp;
	struct cond *lp, *rp, *p;

	lp = NULL;
	for (i = 0; i < COND_N_LEAF; i++) {
		cp = &np->condleaf[i];
		rp = cs_make_leaf(cmdp, cp);
		if (rp == NULL)
			continue;
		if (lp == NULL) {
			lp = rp;
			continue;
		}
		p = xmalloc(sizeof(struct cond));
		if (cp->op == OP_AND) {
			p->cond_op =  COP_NODE | COP_AND;
			if ((rp->cond_op & COP_NOT_CLAUSE) &&
			    (lp->cond_op & COP_NOT_CLAUSE))
				p->cond_op |= COP_NOT_CLAUSE;
		}
		else {
			p->cond_op =  COP_NODE | COP_OR;
			if ((rp->cond_op & COP_NOT_CLAUSE) ||
			    (lp->cond_op & COP_NOT_CLAUSE))
				p->cond_op |= COP_NOT_CLAUSE;
		}
		p->cond_left = lp;
		p->cond_right = rp;
		lp = p;
	}
	return lp;
}

struct cond *
cs_make_leaf(cmdp, cp)
	struct command *cmdp;
	struct condleaf *cp;
{
	struct u_short *sp;
	struct cond *p;

	if (cp->key == NULL)
		return NULL;

	sp = xmalloc(strlen(cp->key) * sizeof(short));
	if (cp->roma == RK_NONE)
		/*
		 *   ޻ѴꤵƤʤϡ
		 *   JISʸѴ
		 */
		han2zen(cp->key, sp, cmdp->code);
	else {
		p->cond_op |= COP_ROMA;
		/*
		 *  ޻ѴԤʤ
		 */
		roma_kana(cp->key, sp, cp->roma);
	}
	if (usstrlen(sp) == 0) {
		xfree(sp);
		return NULL;
	}

	p = xmalloc(sizeof(struct cond));
	p->cond_key = sp;
	p->cond_entry = NULL;
	p->cond_op = COP_LEAF;
	if (cp->not)
		p->cond_op |= COP_NOT | COP_NOT_CLAUSE;

	return p;
}
#endif /* COMPLEX_CONDITION */

/*
 *   ǥå򤿤ɤ
 */
struct entry *
do_index(tp, cmdp, page, key, okey)
	struct toc *tp;
	u_short	*key, *okey;
{
	int	id, type;
	int	off, keylen;
	FILE	*fp = tp->tc_dict->dt_fp;
	struct	entry *ep;

	keylen = usstrlen(key);
	if (keylen == 0)
		return NULL;

	/*
	 *   ǽ̥ڡޤǥǥå򤿤ɤ
	 */
	lockfile(cmdp, tp->tc_dict);
	rewind(fp);
	for (;;) {
		off = (page - 1) * FRAMESIZE;
		if (xfseek(fp, off, SEEK_SET, "search_index") == -1) {
			unlockfile(cmdp);
			return NULL;
		}

		id = getc(fp);
		if (id & 0x80)
			break;

		/* ֥ǥå򤿤ɤ */
		page = do_index_mid(tp, page, id, key, keylen);
	}

	switch (tp->tc_type) {
	case T_INDEX_KANA:
	case T_INDEX_ALPHA:
	case T_INDEX_KANJI:
	case T_INDEX_HYOKI:
		type = TY_EXACT;
		break;
	case T_INDEX_FORW:
	case T_INDEX_FORW_KANA:
	case T_INDEX_FORW_ALPHA:
		type = TY_FORW;
		break;
	case T_INDEX_BACK:
	case T_INDEX_BACK_KANA:
	case T_INDEX_BACK_ALPHA:
		type = TY_BACK;
		break;
	case T_INDEX_CROSS:
		type = TY_CROSS;
		ep =  do_index_cond(tp, page, id, key, type);
		unlockfile(cmdp);
		return ep;
	case T_INDEX_COND:
		type = TY_COND;
		ep =  do_index_cond(tp, page, id, key, type);
		unlockfile(cmdp);
		return ep;
	case T_MULTI_INDEX:
		type = TY_MULTI;
		if (id == 0xc0)
			do_index_multi_c0(tp, page, id, key, keylen, type);
		else if (id == 0xd0)
			do_index_multi_d0(tp, page, id, key, keylen, type);
		else {
			fprintf(stderr, "search_index: multi 0x%02x\n", id);
			exit(1);
		}
		unlockfile(cmdp);
		return NULL;
	default:
		type = TY_EXACT;
		break;
	}

	if (id & 0x10)
		ep = do_index_kana(cmdp, tp, page, id, key, keylen, type, okey);
	else
		ep = do_index_hyouki(cmdp, tp, page, id, key, keylen, type);

	unlockfile(cmdp);
	return ep;
}

/*
 *   ֥ǥå򤿤ɤ
 */
do_index_mid(tp, page, id, key, keylen)
	struct toc *tp;
	u_short *key;
{
	int	i, n, pg, off;
	int	len, nentry;
	FILE	*fp = tp->tc_dict->dt_fp;
	u_short	*p;

	/* intermidiate node */

	len = getc(fp);
	nentry = get_short(fp);
	DPR((stderr, "page: 0x%x, id: 0x%02x, ", page, id));
	DPR((stderr, "keylen: 0x%02x, nentry: 0x%04x\n", len, nentry));
	DPR((stderr, " No: Page      : Key\n"));
	for (n = 0; n < nentry; n++) {
		p = kbuf;
		for (i = 0; i < len; i += 2)
			*p++ = get_short(fp);
		*p = 0;
		pg = get_long(fp);
		if (debug) {
			fprintf(stderr, "%3d: 0x%06x: ", n, pg);
			fprintkey(stderr, kbuf);
			putc('\n', stderr);
		}
		if (usstrcmp(key, kbuf) <= 0)
			break;
	}
	return pg;
}

/*
 *   ñɽκǽڡ
 */
struct entry *
do_index_hyouki(cmdp, tp, page, id, key, keylen, type)
	struct command *cmdp;
	struct toc *tp;
	u_short *key;
{
	int	i, n, hpg, hoff, mpg, moff;
	int	len, nentry;
	FILE	*fp = tp->tc_dict->dt_fp;
	u_short	*p;
	struct	entry *ep, *result;

	result = NULL;
	for (;;) {
		i = getc(fp);
		nentry = get_short(fp);
		DPR((stderr, "page: 0x%x, id: 0x%02x, nentry: %d\n",
			page, id, nentry));

		for (n = 0; n < nentry; n++) {
			p = kbuf;
			len = getc(fp);
			for (i = 0; i < len; i += 2)
				*p++ = get_short(fp);
			*p = 0;
			hpg = get_long(fp);
			hoff = get_short(fp);
			mpg = moff = 0;
			DPR((stderr, "%3d: %06x:%03x ", n, hpg,hoff));
			if (type != TY_EXACT) {
				mpg = get_long(fp);
				moff = get_short(fp);
				DPR((stderr, "%06x:%03x ", mpg,moff));
			}
			if (debug) {
				fprintkey(stderr, kbuf);
				putc('\n', stderr);
			}
			if (type == TY_EXACT || cmdp->type == SD_EXACT)
				i = usstrcmp(key, kbuf);
			else
				i = usstrncmp(key, kbuf, keylen);
			if (i > 0)
				continue;
			if (i < 0)
				return result;
			if ((ep = result) && ep->hpg == hpg && ep->hoff == hoff)
				continue;
			ep = xmalloc(sizeof(struct entry));
			ep->next = result;
			ep->hpg = hpg;
			ep->mpg = mpg;
			ep->hoff = hoff;
			ep->moff = moff;
			ep->pos = 0;
			result = ep;
		}
		if (id == 0xa0 || id == 0xe0)
			break;
		page++;
		hoff = (page - 1) * FRAMESIZE;
		if (xfseek(fp, hoff, SEEK_SET, "do_index_hyouki") == -1)
			return result;
		id = getc(fp);
	}
	return result;
}

/*
 *   ñ줫ʸκǽڡ
 */
struct entry *
do_index_kana(cmdp, tp, page, id, key, keylen, type, okey)
	struct command *cmdp;
	struct toc *tp;
	u_short *key, *okey;
{
	int	c, i, n, hpg, hoff, mpg, moff, code;
	int	len, nentry, ngrp;
	FILE	*fp = tp->tc_dict->dt_fp;
	u_short	*p;
	struct	entry *ep, *result;

	result = NULL;
	ngrp = -1;
	for (;;) {
		i = getc(fp);
		nentry = get_short(fp);
		DPR((stderr, "page: 0x%x, id: 0x%02x, nentry: %d\n",
			page, id, nentry));

		for (n = 0; n < nentry; n++) {
			code = getc(fp);
			if (code == 0x80) {
				len = getc(fp);
				ngrp = get_short(fp);
				p = kbuf;
				for (i = 0; i < len; i += 2)
					*p++ = get_short(fp);
				*p = 0;
				if (debug) {
					fprintf(stderr, "%3d: 80: %2d ",
						n, ngrp);
					fprintkey(stderr, kbuf);
					putc('\n', stderr);
				}
				if (type == TY_EXACT || cmdp->type == SD_EXACT)
					i = usstrcmp(key, kbuf);
				else
					i = usstrncmp(key, kbuf, keylen);
				if (i < 0)
					return result;
				continue;
			}
			else if (code != 0xc0 && code != 0) {
				fprintf(stderr, "do_index_kana: bad code 0x%x",
					code);
				abort();
				continue;
			}
			len = getc(fp);
			p = kbuf;
			for (i = 0; i < len; i += 2) {
				c = get_short(fp);
				*p++ = c;
			}
			*p = 0;
			hpg = get_long(fp);
			hoff = get_short(fp);
			DPR((stderr, "%3d: %02x: %06x:%03x ",
					n, code, hpg, hoff));
					
			if (type != TY_EXACT) {
				mpg = get_long(fp);
				moff = get_short(fp);
				DPR((stderr, "%06x:%03x ", mpg, moff));
			}
			if (debug) {
				fprintkey(stderr, kbuf);
				putc('\n', stderr);
			}
			if (ngrp < 0)
				continue;
			if (type == TY_EXACT)
				i = usstrcmp(okey, kbuf);
			else
				i = usstrncmp(okey, kbuf, keylen);
			if (ngrp > 0)
				ngrp--;
			if (i != 0)
				continue;
			if ((ep = result) &&
			    ep->hpg == hpg && ep->hoff == hoff)
				continue;
			ep = xmalloc(sizeof(struct entry));
			ep->next = result;
			ep->hpg = hpg;
			ep->mpg = mpg;
			ep->hoff = hoff;
			ep->moff = moff;
			ep->pos = 0;
			result = ep;
		}
		if (id == 0xb0 || id == 0xf0)
			break;
		page++;
		hoff = (page - 1) * FRAMESIZE;
		if (xfseek(fp, hoff, SEEK_SET, "do_index_kana") == -1)
			return result;
		id = getc(fp);
	}
	return result;
}

/*
 *   ︡κǽڡ
 */
struct entry *
do_index_cond(tp, page, id, key, type)
	struct toc *tp;
	u_short *key;
{
	int	i, n, code, hpg, hoff, mpg, moff, match;
	int	len, xxx, cnum, cind, nentry;
	FILE	*fp = tp->tc_dict->dt_fp;
	u_short	*p;
	struct	entry *ep, *result;

	match = 0;
	result = NULL;
	mpg = moff = 0;
	for (;;) {
		i = getc(fp);
		nentry = get_short(fp);
		DPR((stderr, "page: 0x%x, id: 0x%02x, nentry: %d\n",
			page, id, nentry));

		for (n = 0; n < nentry; n++) {
			code = getc(fp);
			if (code != 0x00 && code != 0x80 && code != 0xc0) {
				fprintf(stderr,
					"do_index_cond: bad code 0x%x\n", code);
				abort();
				return NULL;
			}
			hpg = hoff = 0;
			switch (code) {
			case 0x00:
				p = kbuf;
				len = getc(fp);
				for (i = 0; i < len; i += 2)
					*p++ = get_short(fp);
				*p = 0;
				hpg = get_long(fp);
				hoff = get_short(fp);
				DPR((stderr, "%3d: 00: %06x:%03x ",
					n, hpg,hoff));
				mpg = get_long(fp);
				moff = get_short(fp);
				DPR((stderr, "%06x:%03x ", mpg, moff));
				cind = 1;
				break;
			case 0x80:
				p = kbuf;
				len = getc(fp);
				xxx = get_short(fp);
				cnum = get_short(fp);
				for (i = 0; i < len; i += 2)
					*p++ = get_short(fp);
				*p = 0;
				DPR((stderr, "%3d: 80: 0x%04x %4d: ",
						n, xxx, cnum));
				mpg = get_long(fp);
				moff = get_short(fp);
				DPR((stderr, "%06x:%03x ", mpg, moff));
				cind = 0;
				break;
			case 0xc0:
				hpg = get_long(fp);
				hoff = get_short(fp);
				DPR((stderr, "%3d: c0: %06x:%03x\n",
						n, hpg, hoff));
				if (match == 0)
					continue;
				break;
			}
			if (code != 0xc0) {
				if (debug) {
					fprintkey(stderr, kbuf);
					putc('\n', stderr);
				}
				i = usstrcmp(key, kbuf);
				if (i > 0)
					continue;
				if (i < 0)
					return result;
				match++;
				if (code == 0x80)
					continue;
			}

			ep = xmalloc(sizeof(struct entry));
			ep->next = result;
			ep->hpg = hpg;
			ep->mpg = mpg;
			ep->hoff = hoff;
			ep->moff = moff;
			ep->pos = code == 0xc0 ? cind++ : 0;
			result = ep;
		}
		if (id == 0xa0 || id == 0xe0)
			break;
		page++;
		hoff = (page - 1) * FRAMESIZE;
		if (xfseek(fp, hoff, SEEK_SET, "do_index_cond") == -1)
			return result;
		id = getc(fp);
	}
	return result;
}

do_index_multi_c0(tp, page, id, key, type)
	struct toc *tp;
{
}

do_index_multi_d0(tp, page, id, key, type)
	struct toc *tp;
{
}

/*
 *   Ȥ줿 entry list νʣ
 */
struct entry *
entry_uniq(ep, type)
	struct entry *ep;
{
	u_long	pg, off;
	struct entry *p, **pp, *p0;

	pg = off = 0xffffffff;
	pp = &ep;
	for (p = ep; p; p = p0) {
		p0 = p->next;
		if ((type & SOT_MASK) == SOT_HONMON) {
			if (p->hoff == off && p->hpg == pg) {
				*pp = p0;
				xfree(p);
				continue;
			}
		}
		else if (p->moff == off && p->mpg == pg) {
			*pp = p0;
			xfree(p);
			continue;
		}
		pg = p->hpg;
		off = p->hoff;
		pp = &p->next;
	}
	return ep;
}

/*
 *   {ʸ, Ф}ǡ entry list {, ߽}ǥ
 */
struct entry *
entry_sort(ep, type)
	struct entry *ep;
{
	int	i, len;
	struct entry *p, **array, **ap;
	int	entry_cmp_hon_asc(), entry_cmp_mid_asc();
	int	entry_cmp_hon_des(), entry_cmp_mid_des();
	int	(*func)();

	if (ep == NULL)
		return ep;
	len = entry_len(ep);

	array = xmalloc(sizeof(struct entry *) * len);
	for (p = ep, ap = array; p; p = p->next, ap++)
		*ap = p;

	if ((type & SOT_MASK) == SOT_HONMON) {
		if ((type & SOD_MASK) == SOD_ASCEND)
			func = entry_cmp_hon_asc;
		else
			func = entry_cmp_hon_des;
	}
	else {
		if ((type & SOD_MASK) == SOD_ASCEND)
			func = entry_cmp_mid_asc;
		else
			func = entry_cmp_mid_des;
	}
	qsort(array, len, sizeof(struct entry *), func);

	ep = p = array[0];
	for (i = 1, ap = &array[1]; i < len; i++, ap++) {
		p->next = *ap;
		p = *ap;
	}
	p->next = NULL;

	xfree(array);
	return ep;
}

/*
 *   ʸǡ򾺽ǥȤ뤿Ӵؿ
 */
entry_cmp_hon_asc(p1, p2)
	struct entry **p1, **p2;
{
	int	val;

	if ((val = p1[0]->hpg - p2[0]->hpg) != 0)
		return val;
	return p1[0]->hoff - p2[0]->hoff;
}

/*
 *   Фǡ򾺽ǥȤ뤿Ӵؿ
 */
entry_cmp_mid_asc(p1, p2)
	struct entry **p1, **p2;
{
	int	val;

	if ((val = p1[0]->mpg - p2[0]->mpg) != 0)
		return val;
	return p1[0]->moff - p2[0]->moff;
}

/*
 *   ʸǡ߽ǥȤ뤿Ӵؿ
 */
entry_cmp_hon_des(p1, p2)
	struct entry **p1, **p2;
{
	int	val;

	if ((val = p2[0]->hpg - p1[0]->hpg) != 0)
		return val;
	return p2[0]->hoff - p1[0]->hoff;
}

/*
 *   Фǡ߽ǥȤ뤿Ӵؿ
 */
entry_cmp_mid_des(p1, p2)
	struct entry **p1, **p2;
{
	int	val;

	if ((val = p2[0]->mpg - p1[0]->mpg) != 0)
		return val;
	return p2[0]->moff - p1[0]->moff;
}

/*
 *   (lp) and (rp)
 */
struct entry *
entry_and_hon(lp, rp)
	struct entry *lp, *rp;
{
	int	val;
	struct entry *ep, *p, *result;

	rp = entry_sort(rp, SOT_HONMON | SOD_ASCEND);
	ep = rp;
	result = NULL;
	while (lp && ep) {
		val = lp->hpg - ep->hpg;
		if (val > 0) {
			ep = ep->next;
			continue;
		}
		if (val < 0) {
			p = lp;
			lp = lp->next;
			xfree(p);
			continue;
		}
		val = lp->hoff - ep->hoff;
		if (val > 0) {
			ep = ep->next;
			continue;
		}
		if (val < 0) {
			p = lp;
			lp = lp->next;
			xfree(p);
			continue;
		}
		p = lp->next;
		lp->next = result;
		result = lp;
		lp = p;
		ep = ep->next;
	}
	if (lp)
		entries_free(lp);
	entries_free(rp);
	reverse(&result);
	return result;
}

/*
 *    (lep) and (not(rep))
 */
struct entry *
entry_and_not_hon(lep, rep)
	struct entry *lep, *rep;
{
	int	val;
	struct entry *lp, *rp, **pp, *p;

	lp = lep;
	pp = &lep;
	rep = entry_sort(rep, SOT_HONMON | SOD_ASCEND);
	rp = rep;
	while (lp && rp) {
		val = lp->hpg - rp->hpg;
		if (val > 0) {
			rp = rp->next;
			continue;
		}
		if (val < 0) {
			pp = &lp->next;
			lp = lp->next;
			continue;
		}
		val = lp->hoff - rp->hoff;
		if (val > 0) {
			rp = rp->next;
			continue;
		}
		if (val < 0) {
			pp = &lp->next;
			lp = lp->next;
			continue;
		}

		p = lp->next;
		xfree(lp);
		*pp = p;

		rp = rp->next;
	}
	entries_free(rp);
	reverse(&lep);
	return lep;
}

/*
 *   entry list 
 */
entries_free(ep)
	struct entry *ep;
{
	struct entry *ep1;
	for (; ep; ep = ep1) {
		ep1 = ep->next;
		xfree(ep);
	}
}

/*
 *   entry list Ĺ
 */
entry_len(ep)
	struct entry *ep;
{
	int	i;

	for (i = 0; ep; ep = ep->next, i++)
		;
	return i;
}
